*DECK EDIDTX
      SUBROUTINE EDIDTX(IPEDIT,IPFLUX,IPMACR,IPRINT,NGROUP,NGCOND,
     >                  NBMIX ,NREGIO,NMERGE,NL    ,NIFISS,NEDMAC,
     >                  NTAUXT,ILEAKS,NWGTH ,ILUPS ,MATCOD,VOLUME,
     >                  KEYFLX,IGCOND,IMERGE,FLUXES,EIGENK,NTENER,
     >                  ENERGY,ENERV ,NSAVES,CURNAM,B2    ,NBMICR,
     >                  HVECT ,NCOMB ,TIMEF ,ITRANC,
     >                  SPH   ,VOLMER,RATECM,FLXINT,SCATTD,DXSTRD,
     >                  DISFCT,NAMEAD,FFUEL ,IFUELR,FACT  ,MATMC ,
     >                  NAMFI ,MIXFI ,MIXFF ,AVGVEL,DIRC  ,FFNFT ,
     >                  EFISS )
C
C---------------------------  EDIDTX  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIDTX
C      USE      : EVALUATE AND PRINT REACTION RATES
C      MODIFIED : 99-02-19 (G.M.)
C                 -> COMPUTE DIRECTIONAL WEIGHTING FACTOR TO
C                    CORRECT BUCKLING WEIGHTED ANISOTROPIC SCATTERING
C                 97-02-06 (G.M.)
C                 94-07-21 (G.M. + I.P.)
C                 91-12-04 (G.M.)
C                 91-04-03 (G.M.)
C                 89-08-24 (G.M.)
C                 88-10-25 (A.H.)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C    INPUT
C      IPEDIT   : POINTER TO THE EDIT                I
C      IPFLUX   : POINTER TO THE SOLUTION            I
C      IPMACR   : POINTER TO THE MACROLIB            I
C      IPRINT   : PRINT LEVEL                        I
C                 = 0 NO PRINT
C                 = 1 PRINT FLUXES
C                 = 2 1+PRINT REACTION RATES
C                 = 3 2+PRINT HOMOGENIZED X-S
C      NGROUP   : NUMBER OF GROUPS                   I
C      NGCOND   : NUMBER OF GROUPS CONDENSED         I
C      NBMIX    : NUMBER OF MIXTURES                 I
C      NREGIO   : NUMBER OF REGIONS                  I
C      NMERGE   : NUMBER OF REGIONS MERGED           I
C      NL       : NUMBER OF LEGENDRE ORDERS          I
C      NIFISS   : NUMBER OF FISSILE ISOTOPES         I
C      NEDMAC   : NUMBER OF EXTRA EDIT VECTORS       I
C      NTAUXT   : NUMBER OF REACTION RATE EDITS      I
C      ILEAKS   : LEAK CALCULATION                   I
C                 = 0 NO LEAKAGE
C                 = 1 LEAKAGE BY SURFACE (ALBEDO>0.0)
C                 = 2 HOMOGENEOUS LEAKAGE COEFFICIENTS
C                 = 3 DIRECTIONAL LEAKAGE COEFFICIENTS
C      NWGTH    : P1 SCATTERING MERGE OPTION         I
C                 = 0 FLUX
C                 = 1 CURRENT
C                 = 2 BUCKLING-WEIGHTED COHERENT
C                 = 3 BUCKLING-WEIGHTED COHERENT
C                     AND DIRECTIONAL CORRECTION
C      ILUPS    : REMOVE UP-SCATTERING FROM OUTPUT   I
C      MATCOD   : MATERIAL PER REGION                I(NREGIO)
C      VOLUME   : VOLUME OF REGION                   R(NREGIO)
C      KEYFLX   : AVERAGE FLUX POSITION PER REGION   I(NREGIO)
C      IGCOND   : LIMIT CONDENSED GROUPS             I(NGCOND)
C      IMERGE   : INDEX OF MERGED REGION             I(NREGIO)
C      FLUXES   : FLUXES                             R(NREGIO,NGROUP)
C      EIGENK   : EIGENVALUE FOR PROBLEM             R
C      NTENER   : ENERGY PRESENCE INDEX              I
C      ENERGY   : GROUP LIMITS                       R(2*NGCOND+1)
C      ENERV    : AVERAGE GROUP ENERGY               R(NGROUP)
C      NSAVES   : HOMOGENIZED X-S COMPUTE, SAVE      I
C                 = 0  NO COMPUTE, NO SAVE
C                 = 1  COMPUTE, NO SAVE
C                 = 2  COMPUTE, SAVE
C                 = 3  COMPUTE, SAVE MICRO PERTURBATION
C      CURNAM   : NAME OF LCM DIRECTORY WHERE THE
C                 MERGED/CONDENSED X-S ARE STORED    C*12
C      B2       : SQUARE BUCKLING                    R(4)
C                 FOR ILEAKS = 2 B2(4) IS HOMOGENEOUS
C                 FOR ILEAKS = 3 B2(1),B2(2),B2(3)
C                 ARE DIRECTIONAL HETEROGENEOUS
C                 AND B2(4) IS HOMOGENEOUS
C      NBMICR   : TYPE OF MICRO EDIT                 I
C      HVECT    : EXTRA EDIT NAMES                   I(NEDMAC)
C      NCOMB    : NUMBER OF REGIONS WITH FUEL        I
C      TIMEF    : TIME/BURNUP/IRRADIATION            R(3)
C                 STAMP IN DAYS FOR DIRECTORY
C      ITRANC   : TYPE OF TRANSPORT CORRECTION       I
C      SPH      : SPH HOMOGENIZATION FACTORS         R(NMERGE,NGCOND)
C      VOLMER   : VOLUME OF REGION MERGED            D(NMERGE)
C      RATECM   : AVERAGED REGION/GROUP X-S          D(0:NMERGE,
C                 = RATECM(*,*,1) = FLUXES             NGCOND,NTAUXT)
C                 = RATECM(*,*,2) = TOTAL
C                 = RATECM(*,*,3) = ABS
C                 = RATECM(*,*,4) = FISSIONS
C                 = RATECM(*,*,5) = PRODUCTIONS
C                 = RATECM(*,*,6) = TOTAL LEAKAGES
C                 = RATECM(*,*,7) = TOTAL OUT OF GROUP SCATTERING
C                 = RATECM(*,*,8) = DIAGONAL SCATTERING X-S
C                 = RATECM(*,*,9) = CHI
C                 = RATECM(*,*,10) = WIMS TYPE TRANSPORT CORRECTION
C                 = RATECM(*,*,11) = X-DIRECTED LEAKAGES
C                 = RATECM(*,*,12) = Y-DIRECTED LEAKAGES
C                 = RATECM(*,*,13) = Z-DIRECTED LEAKAGES
C                 = RATECM(*,*,13+JJ) NUSIGF FOR JJ
C                 = RATECM(*,*,13+NIFISS+JJ) CHI FOR JJ
C                 = RATECM(*,*,13+2*NIFISS+JJ) NFTOT FOR JJ
C                 = RATECM(*,*,13+3*NIFISS+IL) SIGS FOR IL
C                 = RATECM(*,*,13+3*NIFISS+NL+IE) EDIT IE
C                 = RATECM(*,*,NTAUXT)= 1/V MERGE CONDENSED
C      FLXINT   : INTEGRATED FLUX                    R(NREGIO,NGROUP,4)
C      SCATTD   : DOUBLE PRECISION SCATTERING RATES  D(NMERGE,
C                                                      NGCOND,NGCOND,NL)
C      DXSTRD   : EQUIVALENT XS TRANSPORT            D(4,NGCOND,NMERGE)
C      DISFCT   : DISADVANTAGE FACTOR                R(NGCOND)
C      NAMEAD   : EXTRA EDIT NAMES (INT)             I(2,NEDMAC)
C      FFUEL    : NEUTRON PRODUCTION IN FUEL         R(NREGIO,NIFISS)
C      IFUELR   : FUEL REGION LOCATION               I(NREGIO)
C      FACT     : NORMALIZATION VECTOR               R(NMERGE)
C      MATMC    : MATERIAL PER MERGED REGION         I(NMERGE)
C      NAMFI    : NAME OF FISSILE ISOTOPE            I(2,NIFISS)
C      MIXFI    : MATERIAL OF FISSILE ISOTOPE        I(NBMIX,NIFISS)
C      MIXFF    : MATERIAL OF FISSILE ISOTOPE        I(NMERGE,NIFISS)
C      AVGVEL   : NEUTRON AVERAGE VELOCITY           R(NMERGE,NGCOND)
C      DIRC     : ADDED 99-02-19                     D(0:NMERGE,
C                 DIRECTIONAL CORRECTION               NGCOND,3)
C      FFNFT    : FISSION IN FUEL                    R(NREGIO,NIFISS)
C      EFISS    : ENERGY PER FISSION             D(0:NMERGE,0:NIFISS+1)
C
C---------------------------   EDIDTX  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='EDIDTX')
C----
C  LOCAL VARIABLES
C  FOR AVERAGED NEUTRON VELOCITY
C  V=SQRT(2*ENER/M)=SQRT(2/M)*SQRT(ENER)
C  SQFMAS=SQRT(2/M) IN CM/S/SQRT(EV) FOR V IN CM/S AND E IN EV
C        =SQRT(2*1.602189E-19(J/EV)* 1.0E4(CM2/M2) /1.67495E-27 (KG))
C        =1383155.30602 CM/S/SQRT(EV)
C----
      REAL        SQFMAS
      PARAMETER  (SQFMAS=1383155.30602)
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPEDIT,IPFLUX,IPMACR,IPRINT,NGROUP,NGCOND,
     >            NBMIX,NREGIO,NMERGE,NL,NIFISS,NEDMAC,
     >            NTAUXT,ILEAKS,NWGTH,ILUPS,NTENER,NSAVES,
     >            NBMICR,NCOMB,ITRANC
      CHARACTER   CURNAM*12,HVECT(NEDMAC)*6
      INTEGER     MATCOD(NREGIO),KEYFLX(NREGIO),IGCOND(NGCOND),
     >            IMERGE(NREGIO),NAMEAD(2,NEDMAC),IFUELR(NREGIO),
     >            MATMC(NMERGE),NAMFI(2,NIFISS),MIXFI(NBMIX,NIFISS),
     >            MIXFF(NMERGE,NIFISS)
      REAL        VOLUME(NREGIO),FLUXES(NREGIO,NGROUP),EIGENK,
     >            ENERGY(2*NGCOND+1),ENERV(NGROUP),B2(4),TIMEF(3),
     >            SPH(NMERGE,NGCOND),FLXINT(NREGIO,NGROUP,4),
     >            DISFCT(NGCOND),FFUEL(NREGIO,NIFISS),FACT(NMERGE),
     >            AVGVEL(NMERGE,NGCOND),FFNFT(NREGIO,NIFISS)
      DOUBLE PRECISION VOLMER(NMERGE),RATECM(0:NMERGE,NGCOND,NTAUXT),
     >            SCATTD(NMERGE,NGCOND,NGCOND,NL),
     >            DXSTRD(4,NGCOND,NMERGE),DIRC(0:NMERGE,NGCOND,3),
     >            EFISS(0:NMERGE,0:NIFISS+1)
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     ISIGMA,INGSCT,IFGSCT,IPOSCT,IXSCAT,IWORK,
     >            IDLBDG,ISCATC,IDIFF,INJJ,IIJJ,IIPOS,IFGUPS,
     >            IXSFIS
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CGRPNM*12,TEXT12*12,CDUFIS*8
      INTEGER     ILFI,ILSC,ILED,ILOV,IED,IMRG,ITC,NELFI,IFIS,
     >            IREGIO,ICM,IMX,ILCMLN,ILCMTY,NFLUXE,IDIR,IGROUP,
     >            ILOCW,IGRFIN,IGRDEB,IGRC,JGRC,MATNUM,ITF,IBM,
     >            ISIGMX,IRAT,IL,IFLT,ILLT,ILT,ISIGR,NNTOTF
      REAL        FLXFIS,ZNU,FLXNOR
      DOUBLE PRECISION SCATWG,TOTFIS,FXSOUR,FLFUEL,FCELL,FLXREN,
     >            XFSCT,VFUEL,VCELL,DEN,DERR,DXLEAK
C----
C  ALLOCATE WORK VECTOR AND INITIALIZE REQUIRED VECTORS
C----
      CALL SETARA(RBASE,NBMIX*MAX(NIFISS,1)+1,ISIGMA)
      CALL SETARA(IBASE,NBMIX,INGSCT)
      CALL SETARA(IBASE,NBMIX,IFGSCT)
      CALL SETARA(IBASE,NBMIX,IPOSCT)
      CALL SETARA(RBASE,NBMIX*NGROUP,IXSCAT)
      CALL XDRSET(FFUEL,NREGIO*MAX(NIFISS,1),0.0)
      CALL XDRSET(FFNFT,NREGIO*MAX(NIFISS,1),0.0)
      CALL XDRSET(IFUELR,NREGIO,0)
      CALL XDRDBL(DXSTRD,4*NGCOND*NMERGE,0.0D0)
      CALL XDRDBL(VOLMER,NMERGE,0.0D0)
      CALL XDRDBL(RATECM,(NMERGE+1)*NGCOND*NTAUXT,0.0D0)
      CALL XDRDBL(EFISS,(NMERGE+1)*(NIFISS+2),0.0D0)
      RBASE(ISIGMA)=0.0
      ISIGR=ISIGMA+1
      DO 100 IMRG=1,NMERGE
        MATMC(IMRG)=IMRG
 100  CONTINUE
      ILFI=13
      ILSC=ILFI+3*NIFISS
      ILED=ILSC+NL
      ILOV=ILED+NEDMAC+1
C----
C  FIND EDIT XS
C----
      IF(NEDMAC .GT. 0) THEN
        CALL LCMGET(IPMACR,'ADDXSNAME',NAMEAD)
        DO 110 IED=1,NEDMAC
          WRITE(HVECT(IED),'(A4,A2)') (NAMEAD(ITC,IED),ITC=1,2)
 110    CONTINUE
      ENDIF
C----
C  FIND FISSION ISOTOPES AND MIXTURES
C----
      NCOMB=0
      NNTOTF=0
      IF(NIFISS .GT. 0) THEN
        IF(NBMICR .LE. -1) THEN
C----
C  FIND NEW FISSILE MIXTURE
C----
          CALL LCMGET(IPMACR,'FISSIONNAMES',NAMFI)
          CALL LCMGET(IPMACR,'FISSIONNB',MIXFI)
          DO 120 IMRG=1,NMERGE
            NELFI=0
            DO 121 IFIS=1,NIFISS
              DO 122 IREGIO=1,NREGIO
                ICM=IMERGE(IREGIO)
                IMX=MATCOD(IREGIO)
                IF(ICM .EQ. IMRG .AND. MIXFI(IMX,IFIS) .NE. 0) THEN
                  MIXFF(IMRG,IFIS)=IMRG
                  NELFI=NELFI+1
                  GO TO 125
                ENDIF
 122          CONTINUE
              MIXFF(IMRG,IFIS)=0
 125          CONTINUE
 121        CONTINUE
            IF(NELFI .NE. 0) NCOMB=NCOMB+1
 120       CONTINUE
        ELSE
          CDUFIS='MACROFIS'
          READ(CDUFIS,'(2A4)') (NAMFI(ITC,1),ITC=1,2)
          DO 123 IMRG=1,NMERGE
            MIXFF(IMRG,1)=-1
 123      CONTINUE
        ENDIF
      ENDIF
C----
C  COMPUTE MERGED VOLUME AND READ MULTIGROUP FLUXES
C----
      DO 130 IREGIO=1,NREGIO
        IMRG=IMERGE(IREGIO)
        IF(IMRG .GT. 0) THEN
          VOLMER(IMRG)=VOLMER(IMRG)+DBLE(VOLUME(IREGIO))
        ENDIF
 130  CONTINUE
      CALL LCMLEN(IPFLUX,'FLUX  1',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. 0) CALL XABORT(NAMSBR//
     >': MISSING FLUX INFO.')
      CALL SETARA(RBASE,ILCMLN,IWORK)
      NFLUXE=1
      IF(ILEAKS .GE. 2) THEN
        CALL SETARA(RBASE,NGROUP,IDIFF)
        CALL LCMGET(IPFLUX,'DIFFB1HOM',RBASE(IDIFF))
      ENDIF
      IF(ILEAKS .EQ. 3) THEN
        NFLUXE=NFLUXE+3
        DO 141 IGROUP=1,NGROUP
          WRITE(TEXT12,'(4HFLUX,I3)') IGROUP
          CALL LCMGET(IPFLUX,TEXT12,RBASE(IWORK))
          DO 140 IDIR=3,0,-1
            DO 142 IREGIO=1,NREGIO
              ILOCW=IWORK+KEYFLX(IREGIO)+IDIR*NREGIO-1
              FLUXES(IREGIO,IGROUP)=RBASE(ILOCW)
              FLXINT(IREGIO,IGROUP,1+IDIR)=FLUXES(IREGIO,IGROUP)
     >                                    *VOLUME(IREGIO)
 142        CONTINUE
 140      CONTINUE
 141    CONTINUE
        DO 143 IDIR=3,1,-1
          IGRFIN=0
          DO 144 IGRC=1,NGCOND
            IGRDEB=IGRFIN+1
            IGRFIN=IGCOND(IGRC)
            DO 145 IGROUP=IGRDEB,IGRFIN
C----
C  COMPUTE MERGED INTEGRATED CURRENTS
C----
              CALL EDIRAT(0     ,NREGIO,NMERGE,IMERGE,MATCOD,
     >                    FLXINT(1,IGROUP,1+IDIR),RBASE(ISIGMA),
     >                    RATECM(0,IGRC,10+IDIR))
 145        CONTINUE
 144      CONTINUE
 143    CONTINUE
      ELSE IF(ILEAKS .EQ. 2) THEN
        DO 150 IGROUP=1,NGROUP
          WRITE(TEXT12,'(4HFLUX,I3)') IGROUP
          CALL LCMGET(IPFLUX,TEXT12,RBASE(IWORK))
          DO 151 IREGIO=1,NREGIO
            ILOCW=IWORK+KEYFLX(IREGIO)-1
            FLUXES(IREGIO,IGROUP)=RBASE(ILOCW)
            FLXINT(IREGIO,IGROUP,1)=FLUXES(IREGIO,IGROUP)
     >            *VOLUME(IREGIO)
            FLXINT(IREGIO,IGROUP,2)=FLXINT(IREGIO,IGROUP,1)
     >                             *RBASE(IDIFF+IGROUP-1)
            DO 152 IDIR=2,3
              FLXINT(IREGIO,IGROUP,1+IDIR)=FLXINT(IREGIO,IGROUP,2)
 152        CONTINUE
 151      CONTINUE
 150    CONTINUE
        DO 153 IDIR=1,3
          IGRFIN=0
          DO 154 IGRC=1,NGCOND
            IGRDEB=IGRFIN+1
            IGRFIN=IGCOND(IGRC)
            DO 155 IGROUP=IGRDEB,IGRFIN
C----
C  COMPUTE MERGED INTEGRATED CURRENTS
C----
              CALL EDIRAT(     0,NREGIO,NMERGE,IMERGE,MATCOD,
     >                    FLXINT(1,IGROUP,1+IDIR),RBASE(ISIGMA),
     >                    RATECM(0,IGRC,10+IDIR))
 155        CONTINUE
 154      CONTINUE
 153    CONTINUE
      ELSE
        DO 180 IGROUP=1,NGROUP
          WRITE(TEXT12,'(4HFLUX,I3)') IGROUP
          CALL LCMGET(IPFLUX,TEXT12,RBASE(IWORK))
          DO 181 IREGIO=1,NREGIO
            ILOCW=IWORK+KEYFLX(IREGIO)-1
            FLUXES(IREGIO,IGROUP)=RBASE(ILOCW)
            FLXINT(IREGIO,IGROUP,1)=FLUXES(IREGIO,IGROUP)
     >                             *VOLUME(IREGIO)
 181      CONTINUE
 180    CONTINUE
      ENDIF
      CALL RLSARA(RBASE(IWORK))
      IGRFIN=0
      TOTFIS=0.0D0
      FXSOUR=0.0D0
      DO 200 IGRC=1,NGCOND
        IGRDEB=IGRFIN+1
        IGRFIN=IGCOND(IGRC)
        DO 210 IGROUP=IGRDEB,IGRFIN
C----
C  READ FIXE SOURCES/COMPUTE FIXE PRODUCTION RATE AND TOTAL SOURCE
C----
          WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGROUP,NGROUP
          CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
          CALL LCMLEN(IPMACR,'FIXE',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'FIXE',RBASE(ISIGR))
            CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                  VOLUME,RBASE(ISIGMA),RATECM(0,IGRC,5))
            DO 211 IMRG=1,NMERGE
              FXSOUR=FXSOUR+DBLE(RATECM(IMRG,IGRC,5))
 211        CONTINUE
          ENDIF
C----
C  COMPUTE MERGED INTEGRATED FLUX
C----
          CALL EDIRAT(     0,NREGIO,NMERGE,IMERGE,MATCOD,
     >                FLXINT(1,IGROUP,1),RBASE(ISIGMA),
     >                RATECM(0,IGRC,1))
C----
C  READ NUSIGF X-S/ COMPUTE NEUTRON PRODUCTION RATES
C----
          CALL LCMLEN(IPMACR,'NUSIGF',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'NUSIGF',RBASE(ISIGR))
            DO 212 IREGIO=1,NREGIO
              IF(MATCOD(IREGIO) .GT. 0) THEN
                MATNUM=ISIGMA+MATCOD(IREGIO)
                DO 213 IFIS=1,NIFISS
                  IF(RBASE(MATNUM) .GT. 0.0) THEN
                    FLXFIS=FLXINT(IREGIO,IGROUP,1)*RBASE(MATNUM)
                    FFUEL(IREGIO,IFIS)=FFUEL(IREGIO,IFIS)+FLXFIS
                    TOTFIS=TOTFIS+DBLE(FLXFIS)
                    IFUELR(IREGIO)=1
                  ENDIF
                  MATNUM=MATNUM+NBMIX
 213            CONTINUE
              ENDIF
 212        CONTINUE
          ENDIF
C----
C  READ NFTOT X-S/ COMPUTE FISSION RATES
C----
          CALL LCMLEN(IPMACR,'NFTOT',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            NNTOTF=1
            CALL LCMGET(IPMACR,'NFTOT',RBASE(ISIGR))
            DO 214 IREGIO=1,NREGIO
              IF(MATCOD(IREGIO) .GT. 0) THEN
                MATNUM=ISIGMA+MATCOD(IREGIO)
                DO 215 IFIS=1,NIFISS
                  IF(RBASE(MATNUM) .GT. 0.0) THEN
                    FLXFIS=FLXINT(IREGIO,IGROUP,1)*RBASE(MATNUM)
                    FFNFT(IREGIO,IFIS)=FFNFT(IREGIO,IFIS)+FLXFIS
                  ENDIF
                  MATNUM=MATNUM+NBMIX
 215            CONTINUE
              ENDIF
 214        CONTINUE
          ENDIF
          CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 210    CONTINUE
 200  CONTINUE
C----
C  RENORMALIZE FLUXES USING EIGENVALUE IF NOT FIXED SOURCES
C----
      FLXREN=1.0D0
      IF(FXSOUR .EQ. 0.0D0 .AND. TOTFIS .GT. 0.0D0) THEN
        FLXREN=1.0D0/TOTFIS
        DO 220 ITF=1,NFLUXE
          XFSCT=FLXREN
          DO 221 IGROUP=1,NGROUP
            DO 222 IREGIO=1,NREGIO
              FLXINT(IREGIO,IGROUP,ITF)=FLXINT(IREGIO,IGROUP,ITF)
     >                                 *XFSCT
 222        CONTINUE
 221      CONTINUE
 220    CONTINUE
        DO 230 IFIS=1,NIFISS
          DO 231 IREGIO=1,NREGIO
          FFUEL(IREGIO,IFIS)=FFUEL(IREGIO,IFIS)*FLXREN
          FFNFT(IREGIO,IFIS)=FFNFT(IREGIO,IFIS)*FLXREN
 231      CONTINUE
 230    CONTINUE
        DO 240 IGRC=1,NGCOND
          DO 241 IMRG=1,NMERGE
            RATECM(IMRG,IGRC,1)=RATECM(IMRG,IGRC,1)*FLXREN
            IF(ILEAKS .EQ. 3) THEN
              RATECM(IMRG,IGRC,11)=RATECM(IMRG,IGRC,11)*FLXREN
              DXSTRD(2,IGRC,IMRG)=RATECM(IMRG,IGRC,11)
              RATECM(IMRG,IGRC,12)=RATECM(IMRG,IGRC,12)*FLXREN
              DXSTRD(3,IGRC,IMRG)=RATECM(IMRG,IGRC,12)
              RATECM(IMRG,IGRC,13)=RATECM(IMRG,IGRC,13)*FLXREN
              DXSTRD(4,IGRC,IMRG)=RATECM(IMRG,IGRC,13)
            ENDIF
 241      CONTINUE
 240    CONTINUE
      ENDIF
      FLXNOR=FLXREN
C----
C  FIND FUEL VOLUME FOR DISADVANTAGE FACTOR
C----
      VFUEL=0.0D0
      VCELL=0.0D0
      DO 250 IREGIO=1,NREGIO
        IF(IFUELR(IREGIO) .EQ. 1) THEN
          VFUEL=VFUEL+DBLE(VOLUME(IREGIO))
        ENDIF
        VCELL=VCELL+DBLE(VOLUME(IREGIO))
 250  CONTINUE
C----
C  COMPUTE MERGED ENERGY PER FISSION
C----
      CALL LCMLEN(IPMACR,'EFISS',ILCMLN,ILCMTY)
      IF(ILCMLN .GT. 0) THEN
        CALL LCMGET(IPMACR,'EFISS',RBASE(ISIGR))
        ISIGMX=ISIGMA
        DO 251 IFIS=1,NIFISS
          CALL EDIRAT(     0,NREGIO,NMERGE,IMERGE,MATCOD,
     >                FFNFT(1,IFIS),RBASE(ISIGMX),
     >                RATECM(0,1,9))
          CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                FFNFT(1,IFIS),RBASE(ISIGMX),
     >                EFISS(0,IFIS))
          DO 252 IMRG=1,NMERGE
            IF(RATECM(IMRG,1,9) .EQ. 0.0) THEN
              EFISS(IMRG,IFIS)=0.0D0
            ELSE
              EFISS(IMRG,0)=EFISS(IMRG,0)+EFISS(IMRG,IFIS)
              EFISS(IMRG,NIFISS+1)=EFISS(IMRG,NIFISS+1)
     >                            +RATECM(IMRG,1,9)
              EFISS(IMRG,IFIS)=EFISS(IMRG,IFIS)/RATECM(IMRG,1,9)
              RATECM(IMRG,1,9)=0.0D0
            ENDIF
 252      CONTINUE
          RATECM(0,1,9)=0.0D0
          ISIGMX=ISIGMX+NBMIX
 251    CONTINUE
        DO 253 IMRG=1,NMERGE
          IF(EFISS(IMRG,NIFISS+1) .EQ. 0.0) THEN
            EFISS(IMRG,0)=0.0
          ELSE
            EFISS(IMRG,0)=EFISS(IMRG,0)/EFISS(IMRG,NIFISS+1)
          ENDIF
 253    CONTINUE
      ENDIF
      IGRFIN=0
      DO 260 IGRC=1,NGCOND
        FCELL=0.0D0
        FLFUEL=0.0D0
        IGRDEB=IGRFIN+1
        IGRFIN=IGCOND(IGRC)
        DO 280 IGROUP=IGRDEB,IGRFIN
C----
C  COMPUTE INTEGRATED 1/V (ENER IS IN MEV, M IS IN KG)
C  1/V=SQRT(M/2ENER)=SQRT(1.67495E-27/2*1.602189E-19)/SQRT(ENER)
C     =7.2298461E-5/SQRT(ENER) =        S/M
C     =7.2298461E-7/SQRT(ENER) = 1.0/(SQRT(ENER)*SQFMAS) -- S/CM
C  NOTE: SQFMAS=1.0/7.2298461E-7
C----
          IF(NTENER .GT. 0) THEN
             ZNU=1.0/(SQRT(ENERV(IGROUP))*SQFMAS)
             DO 281 IBM=1,NBMIX
               RBASE(ISIGR+IBM-1)=ZNU
 281         CONTINUE
             CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                   FLXINT(1,IGROUP,1),RBASE(ISIGMA),
     >                   RATECM(0,IGRC,ILOV))
          ENDIF
C----
C  TOTAL, ABSORPTION, ECT RATES
C----
          WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGROUP,NGROUP
          CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
          CALL LCMLEN(IPMACR,'TOTAL',ILCMLN,ILCMTY)
          IF(ILCMLN .EQ. 0) CALL XABORT(NAMSBR//
     >    ': READ ERROR FOR RECORD-> TOTAL')
          CALL LCMGET(IPMACR,'TOTAL',RBASE(ISIGR))
          CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                FLXINT(1,IGROUP,1),RBASE(ISIGMA),
     >                RATECM(0,IGRC,2))
          CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                FLXINT(1,IGROUP,1),RBASE(ISIGMA),
     >                RATECM(0,IGRC,3))
c          CALL LCMLEN(IPMACR,'SIGS 0',ILCMLN,ILCMTY)
c          IF(ILCMLN .GT. 0) THEN
c            CALL LCMGET(IPMACR,'SIGS 0',RBASE(ISIGR))
c            CALL EDIRAT(    -1,NREGIO,NMERGE,IMERGE,MATCOD,
c     >                  FLXINT(1,IGR,1),RBASE(ISIGMA),
c     >                  RATECM(0,IGRC,3))
c          ELSE
c            CALL XABORT(NAMSBR//': READ ERROR LCM RECORD= SIGS 0')
c          ENDIF
C----
C  READ ADDITIONAL X-SECTIONS
C----
          IF(NEDMAC .GT. 0) THEN
            DO 282 IED=1,NEDMAC
              CALL LCMGET(IPMACR,HVECT(IED),RBASE(ISIGR))
              CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                    FLXINT(1,IGROUP,1),RBASE(ISIGMA),
     >                    RATECM(0,IGRC,ILED+IED))
 282        CONTINUE
          ENDIF
C----
C  FISSION SPECTRUM AND NU*SIGF
C----
          IRAT=ILFI
          CALL LCMLEN(IPMACR,'NUSIGF',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'NUSIGF',RBASE(ISIGR))
            ISIGMX=ISIGMA
            DO 283 IFIS=1,NIFISS
              CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                    FLXINT(1,IGROUP,1),RBASE(ISIGMX),
     >                    RATECM(0,IGRC,4))
              IF(NBMICR .LE. -1) THEN
                IRAT=IRAT+1
                CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                      FLXINT(1,IGROUP,1),RBASE(ISIGMX),
     >                      RATECM(0,IGRC,IRAT))
              ENDIF
              ISIGMX=ISIGMX+NBMIX
              RBASE(ISIGMX)=0.0
 283        CONTINUE
          ENDIF
          IRAT=ILFI+NIFISS
          CALL LCMLEN(IPMACR,'CHI',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'CHI',RBASE(ISIGR))
            ISIGMX=ISIGMA
            DO 284 IFIS=1,NIFISS
              CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                    FFUEL(1,IFIS),RBASE(ISIGMX),
     >                    RATECM(0,IGRC,5))
              IF(NBMICR .LE. -1) THEN
                IRAT=IRAT+1
                CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                      FFUEL(1,IFIS),RBASE(ISIGMX),
     >                      RATECM(0,IGRC,IRAT))
              ENDIF
              ISIGMX=ISIGMX+NBMIX
              RBASE(ISIGMX)=0.0
 284        CONTINUE
          ENDIF
          IRAT=ILFI+2*NIFISS
          IF(NNTOTF .EQ. 1) THEN
            CALL LCMLEN(IPMACR,'NFTOT',ILCMLN,ILCMTY)
            IF(ILCMLN .GT. 0) THEN
              CALL LCMGET(IPMACR,'NFTOT',RBASE(ISIGR))
              ISIGMX=ISIGMA
              DO 286 IFIS=1,NIFISS
                IRAT=IRAT+1
                CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                      FLXINT(1,IGROUP,1),RBASE(ISIGMX),
     >                      RATECM(0,IGRC,IRAT))
                ISIGMX=ISIGMX+NBMIX
                RBASE(ISIGMX)=0.0
 286          CONTINUE
            ENDIF
          ENDIF
          DO 285 IREGIO=1,NREGIO
            IF(IFUELR(IREGIO) .EQ. 1) THEN
              FLFUEL=FLFUEL+DBLE(FLXINT(IREGIO,IGROUP,1))
            ENDIF
            FCELL=FCELL+DBLE(FLXINT(IREGIO,IGROUP,1))
 285      CONTINUE
C----
C  TYPE TRANSPORT CORRECTION
C----
          CALL LCMLEN(IPMACR,'TRANC',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'TRANC',RBASE(ISIGR))
            CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                  FLXINT(1,IGROUP,1),RBASE(ISIGMA),
     >                  RATECM(0,IGRC,10))
          ENDIF
C----
C  LEAKAGE EFFECTS
C----
          IF(ILEAKS .GE. 2) THEN
            DXLEAK=RBASE(IDIFF+IGROUP-1)
            DO 300 IREGIO=1,NREGIO
              IMRG=IMERGE(IREGIO)
              IF(IMRG .GT. 0) THEN
                DXSTRD(1,IGRC,IMRG)=DXSTRD(1,IGRC,IMRG)+
     >             DBLE(FLXINT(IREGIO,IGROUP,1))*DXLEAK
                RATECM(IMRG,IGRC,6)=RATECM(IMRG,IGRC,6)+
     >             DBLE(FLXINT(IREGIO,IGROUP,1))*DXLEAK
              ENDIF
 300        CONTINUE
          ENDIF
          CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 280    CONTINUE
        IF(VFUEL*FCELL .GT. 0.0D0) THEN
          DISFCT(IGRC)=FLFUEL*VCELL/(VFUEL*FCELL)
        ELSE
          DISFCT(IGRC)=0.0
        ENDIF
 260  CONTINUE
C----
C  SCATTERING NEUTRONS
C  99-02-19
C  PASS TO EDISCT DOUBLE PRECISION VECTOR "DIRC" FOR DIRECTIONAL
C  ANISOTROPIC SCATTERING CORRECTION AND VECTOR B2 SINCE
C  CURRENT NO LONGUER MULTIPLIED BY B2(K)
C----
      CALL SETARA(RBASE,NGROUP*2,IDLBDG)
      CALL EDISCT(IPMACR,IPRINT,NGROUP,NGCOND,NBMIX ,NREGIO,
     >            NMERGE,NL    ,NIFISS,NTAUXT,ILEAKS,NWGTH ,
     >            MATCOD,IGCOND,IMERGE,SPH   ,RATECM,FLXINT,
     >            SCATTD,B2    ,DIRC  ,
     >            RBASE(ISIGMA),IBASE(INGSCT),IBASE(IFGSCT),
     >            IBASE(IPOSCT),RBASE(IXSCAT),RBASE(IDLBDG))
      CALL RLSARA(RBASE(IDLBDG))
      IF(ILEAKS .GE. 2) CALL RLSARA(RBASE(IDIFF))
C----
C  UP-SCATTERING CORRECTIONS
C----
      IF(ILUPS .EQ. 1) THEN
        DO 310 IMRG=1,NMERGE
          DO 311 IGRC=2,NGCOND
            DO 312 JGRC=1,IGRC-1
              DO 313 IL=1,NL
                SCATTD(IMRG,IGRC,JGRC,IL)=SCATTD(IMRG,IGRC,JGRC,IL)
     >                                   -SCATTD(IMRG,JGRC,IGRC,IL)
                SCATTD(IMRG,JGRC,IGRC,IL)=0.0D0
 313          CONTINUE
 312        CONTINUE
 311      CONTINUE
 310    CONTINUE
      ENDIF
C----
C  SCATTERING NORMALIZATION
C----
      DO 320 IGRC=1,NGCOND
        DO 321 IMRG=1,NMERGE
          DO 322 IL=1,NL
            SCATWG=RATECM(IMRG,IGRC,ILSC+IL)
            DO 323 JGRC=1,NGCOND
              IF(JGRC .NE. IGRC)
     >        SCATWG=SCATWG-SCATTD(IMRG,JGRC,IGRC,IL)
 323        CONTINUE
            DEN=MAX(ABS(SCATWG),ABS(SCATTD(IMRG,IGRC,IGRC,IL)))
            IF(DEN .GT. 0.0) THEN
              DERR=ABS(SCATWG-SCATTD(IMRG,IGRC,IGRC,IL))/DEN
              IF(DERR .GT. 1.0D-3) THEN
                WRITE(IOUT,6000) NAMSBR,IL,IGRC,IMRG,100.0*DERR
              ENDIF
              SCATTD(IMRG,IGRC,IGRC,IL)=SCATWG
            ENDIF
 322      CONTINUE
 321    CONTINUE
 320  CONTINUE
C----
C  FISSION SPECTRUM NORMALIZATION
C----
      IF(FXSOUR .EQ. 0.0D0 .AND. TOTFIS .GT. 0.0D0 ) THEN
        IF(NBMICR .LE. -1) THEN
          IRAT=ILFI+NIFISS
          DO 330 IFIS=1,NIFISS
            IRAT=IRAT+1
            DO 340 IGRC=1,NGCOND
              DO 341 IMRG=0,NMERGE
                RATECM(IMRG,IGRC,9)=0.0D0
 341          CONTINUE
 340        CONTINUE
            DO 342 IGRC=1,NGCOND
              CALL EDIRAT(     0,NREGIO,NMERGE,IMERGE,MATCOD,
     >                    FFUEL(1,IFIS),RBASE(ISIGMA),
     >                    RATECM(0,IGRC,9))
 342        CONTINUE
            DO 343 IGRC=1,NGCOND
              DO 344 IMRG=1,NMERGE
                IF(RATECM(IMRG,IGRC,9) .NE. 0.0D0) THEN
                  RATECM(IMRG,IGRC,IRAT)=RATECM(IMRG,IGRC,IRAT)
     >                                  /RATECM(IMRG,IGRC,9)
                ELSE
                  RATECM(IMRG,IGRC,IRAT)=0.0D0
                ENDIF
 344          CONTINUE
 343        CONTINUE
 330      CONTINUE
        ENDIF
        DO 350 IGRC=1,NGCOND
          DO 351 IFIS=1,NIFISS
            CALL EDIRAT(     0,NREGIO,NMERGE,IMERGE,MATCOD,
     >                  FFUEL(1,IFIS),RBASE(ISIGMA),
     >                  RATECM(0,IGRC,9))
 351      CONTINUE
 350    CONTINUE
        DO 360 IGRC=1,NGCOND
          DO 361 IMRG=1,NMERGE
            IF(RATECM(IMRG,IGRC,9) .NE. 0.0D0) THEN
              RATECM(IMRG,IGRC,9)=RATECM(IMRG,IGRC,5)
     >                           /RATECM(IMRG,IGRC,9)
            ENDIF
 361      CONTINUE
 360    CONTINUE
      ENDIF
      CALL RLSARA(RBASE(IXSCAT))
      CALL RLSARA(IBASE(IPOSCT))
      CALL RLSARA(IBASE(IFGSCT))
      CALL RLSARA(IBASE(INGSCT))
      CALL RLSARA(RBASE(ISIGMA))
C----
C  RESET FLUX TO FLUX/SPH
C----
      DO 370 IGRC=1,NGCOND
        DO 371 IMRG=1,NMERGE
          RATECM(IMRG,IGRC,1)=RATECM(IMRG,IGRC,1)/SPH(IMRG,IGRC)
 371    CONTINUE
 370  CONTINUE
C----
C  PRINT REACTION RATES
C----
      IF(IPRINT.GE.1) THEN
        CALL EDIPRR(IPRINT,NGCOND,NMERGE,NL    ,NIFISS,NEDMAC,
     >              NTAUXT,ILEAKS,NTENER,B2    ,ENERGY,SPH   ,
     >              VOLMER,RATECM,SCATTD)
      ENDIF
C----
C  COMPUTE MERGED/CONDENSED X-S
C----
      IF(NSAVES .EQ. 2) THEN
        CALL LCMSIX(IPEDIT,CURNAM,ILCMUP)
        CALL LCMPUT(IPEDIT,'FLXNORMALIZE',1,2,FLXNOR)
      ENDIF
      CALL SETARA(RBASE,NGCOND*2,IDLBDG)
      CALL SETARA(RBASE,NMERGE*NGCOND,ISCATC)
      CALL SETARA(RBASE,NGCOND,IDIFF)
      CALL SETARA(IBASE,NMERGE,INJJ)
      CALL SETARA(IBASE,NMERGE,IIJJ)
      CALL SETARA(IBASE,NMERGE,IIPOS)
      CALL SETARA(IBASE,NMERGE*NL,IFGUPS)
      CALL SETARA(RBASE,NMERGE*MAX(NIFISS,1),IXSFIS)
      CALL EDIPXS(IPEDIT,IPRINT,NSAVES,NGCOND,NMERGE,NL    ,
     >            NIFISS,NEDMAC,NTAUXT,ILEAKS,NWGTH ,NTENER,
     >            NBMICR,ITRANC,EIGENK,B2    ,ENERGY,VOLMER,
     >            RATECM,SCATTD,EFISS ,DISFCT,NAMEAD,MATMC ,
     >            FACT  ,TIMEF ,SPH   ,HVECT ,NAMFI ,MIXFI ,
     >            MIXFF ,DIRC  ,NNTOTF,
     >            RBASE(ISCATC),RBASE(IDIFF) ,IBASE(IIJJ)  ,
     >            IBASE(INJJ)  ,IBASE(IIPOS) ,IBASE(IFGUPS),
     >            RBASE(IXSFIS),RBASE(IDLBDG))
      CALL RLSARA(RBASE(IXSFIS))
      CALL RLSARA(IBASE(IFGUPS))
      CALL RLSARA(IBASE(IIPOS))
      CALL RLSARA(IBASE(IIJJ))
      CALL RLSARA(IBASE(INJJ))
      CALL RLSARA(RBASE(IDIFF))
      CALL RLSARA(RBASE(ISCATC))
      CALL RLSARA(RBASE(IDLBDG))
C----
C  STRD CROSS SECTIONS.
C----
      IF(ILEAKS .GE. 2) THEN
        IFLT=1
        ILLT=1
        IF(ILEAKS .EQ. 3) ILLT=4
        DO 372 IMRG=1,NMERGE
          DO 373 IGRC=1,NGCOND
            IF(NL .GE. 2) THEN
              FLXREN=RATECM(IMRG,IGRC,1)/
     >        (3.0D0*(RATECM(IMRG,IGRC,2)-RATECM(IMRG,IGRC,ILSC+2)))
            ELSE
              FLXREN=RATECM(IMRG,IGRC,1)/
     >        (3.0D0*RATECM(IMRG,IGRC,2))
            ENDIF
            DO 374 ILT=IFLT,ILLT
              IF(DXSTRD(ILT,IGRC,IMRG) .NE. 0.0D0) THEN
                DXSTRD(ILT,IGRC,IMRG)=FLXREN/DXSTRD(ILT,IGRC,IMRG)
              ENDIF
 374        CONTINUE
 373      CONTINUE
 372    CONTINUE
      ELSE
        ILT=1
        DO 376 IMRG=1,NMERGE
          DO 377 IGRC=1,NGCOND
            DXSTRD(ILT,IGRC,IMRG)=1.0D0
 377      CONTINUE
 376    CONTINUE
      ENDIF
C----
C  SAVE AVERAGE NEUTRON VELOCITY
C----
      DO 380 IGRC=1,NGCOND
        DO 381 IMRG=1,NMERGE
          IF(RATECM(IMRG,IGRC,ILOV) .NE. 0.0D0) THEN
            AVGVEL(IMRG,IGRC)=REAL(1.0D0/RATECM(IMRG,IGRC,ILOV))
          ELSE
            AVGVEL(IMRG,IGRC)=0.0
          ENDIF
 381    CONTINUE
 380  CONTINUE
      IF(NSAVES .EQ. 2) THEN
        IF(IPRINT .GT. 0) WRITE(IOUT,6001) NAMSBR,CURNAM
        CALL LCMSIX(IPEDIT,CURNAM,ILCMDN)
      ENDIF
      RETURN
C----
C  FORMAT
C----
 6000 FORMAT(1X,A6,':*** WARNING *** NORMALIZATION OF THE ',
     > 'WITHIN-GROUP SCATTERING TRANSFER OF ORDER ',I3,
     > ' IN GROUP ',I4,' AND REGION ',I5,' BY ',F6.2,' %')
 6001 FORMAT(/1X,A6,' MERGED/CONDENSED X-S SAVED IN DIRECTORY = ', A12)
      END
