*DECK GEOIN3
      SUBROUTINE GEOIN3(GEONAM,IPLIST,LEVEL,IMPX,MAXMIX)
C
C-----------------------------------------------------------------------
C
C READ AND/OR MODIFY AN OBJECT ORIENTED GEOMETRY.
C
C INPUT PARAMETERS:
C   GEONAM : CHARACTER*12 NAME OF THE DIRECTORY WHERE THE GEOMETRY IS
C            STORED.
C   IPLIST : POINTER TO THE GEOMETRY (L_GEOM SIGNATURE).
C   LEVEL  : HIERARCHICAL LEVEL OF THE GEOMETRY.
C   IMPX   : PRINT FLAG. IMPX=0 FOR NO PRINT.
C
C OUTPUT PARAMETER:
C   MAXMIX : MAXIMUM NUMBER OF MIXTURES, CONSIDERING ALL SUB GEOMETRIES.
C
C-------------------------------------- AUTHOR: A. HEBERT ; 10/11/89 ---
C
      IMPLICIT NONE
C----
C  PARAMETERS
C----
      INTEGER      MAXCOD,MAXHEX,MAXTUR,MAXTYP,MXCL,NSTATE,IOUT
      PARAMETER   (MAXCOD=10,MAXHEX=9,MAXTUR=12,MAXTYP=30,MXCL=500,
     >             NSTATE=20,IOUT=6)
C----
C  MEMORY ALLOCATION
C----
      INTEGER      IBASE(1)
      REAL         BASE
      COMMON       BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
      INTEGER      IMIX,IMESH,ICYL,ICENT,ICELL,IIGEN,IMERGE,ITURN,INS,
     &             IRS,IMIXDL,IMIXGR,IMILIE,IFRACT,IPOURC,IPROCE
C----
C  LOCAL VARIABLES
C----
      REAL         ZCODE(6),FLOTT,SIDE,PIN
      INTEGER      ISTATE(NSTATE),NCODE(6),ICODE(6),KCHAR(3),
     &             LR,LX,LY,LZ,LREG,MINMIX,MINICO,IPLIST,ILONG,
     &             ITYX,I,J,K,I1,LEVEL,INDC,NITMA,IRLXY,IRLYZ,IFILE,
     &             IRC,IMPX,LMESH,LCYL,IKG,JKG,NPIN,MICRO,NG,
     &             IOFJ,IOFK,NMILG,NSMAX,ISURF,IHEX,MAXMIX
      CHARACTER    GEONAM*12,COND(MAXCOD)*4,CHEX(MAXHEX)*8,
     &             CTUR(MAXTUR)*1,TYPE(0:MAXTYP)*16,TEXT4*4,
     &             TEXT12*12,TEXT13*12,NAMT*12,DIR*1,NAMSBR*6
      LOGICAL      LHEX,LCM
      DOUBLE PRECISION DBLINP
C----
C  EXTERNALS
C----
      INTEGER      KDROPN,KDRCLS
C----
C  DATA
C----
      SAVE         COND,CHEX,CTUR,TYPE
      EQUIVALENCE (LR,ISTATE(2)),(LX,ISTATE(3)),(LY,ISTATE(4)),
     1 (LZ,ISTATE(5)),(LREG,ISTATE(6))
      DATA     COND/'VOID','REFL','DIAG','TRAN','SYME',
     1              'ALBE','ZERO','CYLI','ACYL','SSYM'/
      DATA     CHEX/'S30','SA60','SB60','S90','R120','R180','SA180',
     1              'SB180','COMPLETE'/
      DATA     CTUR/'A','B','C','D','E','F','G','H','I','J','K','L'/
      DATA     TYPE/'VIRTUAL','HOMOGENEOUS','CARTESIAN 1-D','TUBE 1-D',
     1         'SPHERE 1-D','CARTESIAN 2-D','TUBE 2-D','CARTESIAN 3-D',
     2         'HEXAGONAL 2-D','HEXAGONAL 3-D',10*' ','2-D RECT. CELL',
     3       3*'3-D RECT. CELL','2-D HEX. CELL','3-D HEX. CELL',4*' ',
     4         'DO-IT-YOURSELF'/
*
      NAMSBR='GEOIN3'
      MINMIX=0
      MINICO=1
      CALL LCMLEN(IPLIST,'SIGNATURE',ILONG,ITYX)
      IF(ILONG.EQ.0) THEN
*        INPUT A NEW GEOMETRY.
         CALL XDRSET(ISTATE,NSTATE,0)
         LHEX=.FALSE.
         DO 20 I=1,6
         NCODE(I)=0
         ZCODE(I)=0.0
   20    ICODE(I)=0
      ELSE
*        MODIFY AN EXISTING GEOMETRY.
         CALL LCMGET(IPLIST,'SIGNATURE',KCHAR)
         WRITE(TEXT12,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(TEXT12.NE.'L_GEOM') THEN
            CALL XABORT(NAMSBR//': SIGNATURE OF '//GEONAM//' IS '
     1      //TEXT12//'. L_GEOM EXPECTED.')
         ENDIF
         CALL XDRSET(ISTATE,NSTATE,0)
         CALL LCMGET(IPLIST,'STATE-VECTOR',ISTATE)
         LHEX=(ISTATE(1).EQ.8).OR.(ISTATE(1).EQ.9).OR.(ISTATE(1).EQ.24)
     1   .OR.(ISTATE(1).EQ.25)
         CALL LCMGET(IPLIST,'NCODE',NCODE)
         CALL LCMGET(IPLIST,'ZCODE',ZCODE)
         CALL LCMGET(IPLIST,'ICODE',ICODE)
         IF(LEVEL.EQ.1) GO TO 30
      ENDIF
*
      CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
      IF(INDC.NE.3) CALL XABORT
     >  (NAMSBR//': CHARACTER DATA EXPECTED(1).')
      IF(TEXT12.EQ.'VIRTUAL') THEN
         ISTATE(1)=0
      ELSE IF(TEXT12.EQ.'HOMOGE') THEN
         ISTATE(1)=1
         LREG=1
      ELSE IF(TEXT12.EQ.'CAR1D') THEN
         ISTATE(1)=2
         CALL REDGET(INDC,LX,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LREG=LX
      ELSE IF(TEXT12.EQ.'TUBE') THEN
         ISTATE(1)=3
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LR=NITMA
         LREG=LR
      ELSE IF(TEXT12.EQ.'SPHERE') THEN
         ISTATE(1)=4
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LR=NITMA
         LREG=LR
      ELSE IF(TEXT12.EQ.'CAR2D') THEN
         ISTATE(1)=5
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LX=NITMA
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LY=NITMA
         LREG=LX*LY
      ELSE IF(TEXT12.EQ.'TUBEZ') THEN
         ISTATE(1)=6
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LR=NITMA
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LZ=NITMA
         LREG=LR*LZ
      ELSE IF(TEXT12.EQ.'CAR3D') THEN
         ISTATE(1)=7
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LX=NITMA
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LY=NITMA
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LZ=NITMA
         LREG=LX*LY*LZ
      ELSE IF(TEXT12.EQ.'HEX') THEN
         ISTATE(1)=8
         LHEX=.TRUE.
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LX=NITMA
         LREG=LX
      ELSE IF(TEXT12.EQ.'HEXZ') THEN
         ISTATE(1)=9
         LHEX=.TRUE.
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LX=NITMA
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LZ=NITMA
         LREG=LX*LZ
      ELSE IF(TEXT12(1:6).EQ.'CARCEL') THEN
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LR=NITMA
         DIR=TEXT12(7:7)
         IF(DIR .EQ. ' ') THEN
           ISTATE(1)=20
           LX=1
           LY=1
           IRLXY=1
           CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
           IF(INDC .EQ. 3) THEN
             IRLXY=0
           ELSE IF(INDC.EQ. 2) THEN
             CALL XABORT(NAMSBR//': INVALID REAL DATA.')
           ELSE
             LX=NITMA
             CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
             IF(INDC.NE.1) CALL XABORT
     >         (NAMSBR//': INTEGER DATA EXPECTED.')
             LY=NITMA
           ENDIF
           LREG=(LR+1)*LY*LX
           IF(IRLXY .EQ. 0 ) GO TO 35
         ELSE
           LX=1
           LY=1
           LZ=1
           CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
           IF(INDC.NE.1) CALL XABORT
     >       (NAMSBR//': INTEGER DATA EXPECTED.')
           LX=NITMA
           CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
           IF(INDC .EQ. 3) THEN
             IRLYZ=0
           ELSE IF(INDC.EQ. 2) THEN
             CALL XABORT(NAMSBR//': INVALID REAL DATA.')
           ELSE
             LY=NITMA
             IRLYZ=1
             CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
             IF(INDC.NE.1) CALL XABORT
     >         (NAMSBR//': INTEGER DATA EXPECTED.')
             LZ=NITMA
           ENDIF
           LREG=(LR+1)*LY*LZ*LX
           IF(DIR .EQ. 'X') THEN
             ISTATE(1)=21
           ELSE IF(DIR .EQ. 'Y') THEN
             ISTATE(1)=22
             IF(IRLYZ .EQ.0 ) THEN
               LY=LX
               LX=1
               GO TO 35
             ENDIF
           ELSE IF(DIR .EQ. 'Z') THEN
             ISTATE(1)=23
             IF(IRLYZ .EQ.0 ) THEN
               LZ=LX
               LX=1
               GO TO 35
             ENDIF
           ELSE
             GO TO 500
           ENDIF
         ENDIF
      ELSE IF(TEXT12(1:6).EQ.'HEXCEL') THEN
         LHEX=.TRUE.
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LR=NITMA
         LX=1
         IF(TEXT12(7:7).EQ.' ') THEN
            ISTATE(1)=24
            LREG=LR+1
         ELSE IF(TEXT12(7:7).EQ.'Z') THEN
            ISTATE(1)=25
            CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
            IF(INDC.NE.1) CALL XABORT
     >        (NAMSBR//': INTEGER DATA EXPECTED.')
            LZ=NITMA
            LREG=(LR+1)*LZ
         ELSE
            GO TO 500
         ENDIF
      ELSE IF(TEXT12.EQ.'GROUP') THEN
*        DO-IT-YOURSELF OPTION.
         ISTATE(1)=30
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         LX=NITMA
         LREG=LX
      ELSE IF(TEXT12.NE.GEONAM) THEN
*        COPY ATTRIBUTES FROM AN EXISTING GEOMETRY LOCATED ON A PARALLEL
*        DIRECTORY OF THE LINKED LIST POINTED BY IPLIST.
         IF(LEVEL.EQ.1) CALL XABORT
     >     (NAMSBR//': THE GEOMETRY NAME SHOULD APPEARS BEFORE THE ::')
         CALL LCMSIX(IPLIST,' ',2)
         CALL LCMLEN(IPLIST,TEXT12,ILONG,ITYX)
         IF(ILONG.EQ.0) CALL XABORT(NAMSBR//': UNKNOWN GEOMETRY.')
         CALL LCMSIX(IPLIST,TEXT12,1)
         IFILE=KDROPN('DUMMYSQ',0,2,0,0)
         IF(IFILE.LE.0) CALL XABORT(NAMSBR//': KDROPN FAILURE.')
         CALL LCMEXP(IPLIST,0,IFILE,1,1)
         REWIND(IFILE)
         CALL LCMSIX(IPLIST,' ',2)
         CALL LCMSIX(IPLIST,GEONAM,1)
         CALL LCMEXP(IPLIST,0,IFILE,1,2)
         IRC=KDRCLS(IFILE,2)
         IF(IRC.LT.0) CALL XABORT(NAMSBR//': KDRCLS FAILURE.')
         CALL LCMGET(IPLIST,'STATE-VECTOR',ISTATE)
         LHEX=(ISTATE(1).EQ.8).OR.(ISTATE(1).EQ.9).OR.(ISTATE(1).EQ.24)
     1   .OR.(ISTATE(1).EQ.25)
         CALL LCMGET(IPLIST,'NCODE',NCODE)
         CALL LCMGET(IPLIST,'ZCODE',ZCODE)
         CALL LCMGET(IPLIST,'ICODE',ICODE)
      ENDIF
*
   30 CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
      IF(INDC.NE.3) CALL XABORT(NAMSBR//': CHARACTER DATA EXPECTED(2).')
   35 IF(TEXT12.EQ.'EDIT') THEN
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         IMPX=NITMA
      ELSE IF(TEXT12.EQ.'MIX') THEN
*        INPUT MIXTURE NUMBERS.
         CALL SETARA(IBASE,LREG,IMIX)
         CALL XDRSET(IBASE(IMIX),LREG,0)
         I=0
   40    I=I+1
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.EQ.3) GO TO 50
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         IF(I.GT.LREG) GO TO 500
         IBASE(IMIX+I-1)=NITMA
         ISTATE(7)=MAX(ISTATE(7),IBASE(IMIX+I-1))
         MINMIX=MIN(MINMIX,IBASE(IMIX+I-1))
         GO TO 40
   50    LREG=I-1
         CALL LCMPUT(IPLIST,'MIX',LREG,1,IBASE(IMIX))
         CALL RLSARA(IBASE(IMIX))
         GO TO 35
      ELSE IF(TEXT12(1:4).EQ.'MESH') THEN
*        INPUT CARTESIAN COORDINATES.
         IF(TEXT12(5:5).EQ.'X') THEN
            IF(LX.EQ.0) GO TO 500
            LMESH=LX+1
         ELSE IF(TEXT12(5:5).EQ.'Y') THEN
            IF(LY.EQ.0) GO TO 500
            LMESH=LY+1
         ELSE IF(TEXT12(5:5).EQ.'Z') THEN
            IF(LZ.EQ.0) GO TO 500
            LMESH=LZ+1
         ELSE
            GO TO 500
         ENDIF
         CALL SETARA(BASE,LMESH,IMESH)
         DO 60 I=1,LMESH
         CALL REDGET(INDC,NITMA,BASE(IMESH+I-1),TEXT13,DBLINP)
         IF(INDC.NE.2) CALL XABORT(NAMSBR//': REAL DATA EXPECTED.')
         IF(I.GT.1) THEN
            IF(BASE(IMESH+I-1).LE.BASE(IMESH+I-2)) GO TO 500
         ENDIF
   60    CONTINUE
         CALL LCMPUT(IPLIST,TEXT12,LMESH,2,BASE(IMESH))
         CALL RLSARA(BASE(IMESH))
      ELSE IF(TEXT12.EQ.'RADIUS') THEN
*        INPUT TUBE RADIUS.
         IF(LR.EQ.0) GO TO 500
         LCYL=LR+1
         CALL SETARA(BASE,LCYL,ICYL)
         DO 70 I=1,LCYL
         CALL REDGET(INDC,NITMA,BASE(ICYL+I-1),TEXT12,DBLINP)
         IF(INDC.NE.2) CALL XABORT(NAMSBR//': REAL DATA EXPECTED.')
         IF(I.GT.1) THEN
            IF(BASE(ICYL+I-1).LE.BASE(ICYL+I-2)) GO TO 500
         ENDIF
   70    CONTINUE
         IF(BASE(ICYL).NE.0.0) GO TO 500
         CALL LCMPUT(IPLIST,'RADIUS',LCYL,2,BASE(ICYL))
         CALL RLSARA(BASE(ICYL))
      ELSE IF(TEXT12.EQ.'OFFCENTER') THEN
*        INPUT TUBE CENTER LOCATION (USE FOR CARCEL* ONLY).
         IF(LR.EQ.0) GO TO 500
         CALL SETARA(BASE,3,ICENT)
         CALL XDRSET(BASE(ICENT),3,0.0)
         DO 71 I=1,3
           CALL REDGET(INDC,NITMA,BASE(ICENT+I-1),TEXT12,DBLINP)
           IF(INDC.NE.2) GO TO 72
 71      CONTINUE
         CALL REDGET(INDC,NITMA,BASE(ICENT+I-1),TEXT12,DBLINP)
 72      CONTINUE
         CALL LCMPUT(IPLIST,'OFFCENTER',3,2,BASE(ICENT))
         CALL RLSARA(BASE(ICENT))
         GO TO 35
      ELSE IF(TEXT12.EQ.'SIDE') THEN
*        INPUT THE SIDE LENGTH IN HEXAGONAL GEOMETRY.
         IF(.NOT.LHEX) CALL XABORT(NAMSBR//': SIDE PROHIBITED.')
         CALL REDGET(INDC,NITMA,SIDE,TEXT12,DBLINP)
         IF(INDC.NE.2) CALL XABORT(NAMSBR//': REAL DATA EXPECTED.')
         CALL LCMPUT(IPLIST,'SIDE',1,2,SIDE)
      ELSE IF(TEXT12(1:5).EQ.'SPLIT') THEN
*        INPUT MESH SPLITTING FACTORS.
         ISTATE(11)=1
         IF(TEXT12(6:6).EQ.'X') THEN
            IF(LX.EQ.0) GO TO 500
            LMESH=LX
         ELSE IF(TEXT12(6:6).EQ.'Y') THEN
            IF(LY.EQ.0) GO TO 500
            LMESH=LY
         ELSE IF(TEXT12(6:6).EQ.'Z') THEN
            IF(LZ.EQ.0) GO TO 500
            LMESH=LZ
         ELSE IF(TEXT12(6:6).EQ.'R') THEN
            IF(LR.EQ.0) GO TO 500
            LMESH=LR
         ELSE
            GO TO 500
         ENDIF
         CALL SETARA(IBASE,LMESH,IMESH)
         DO 80 I=1,LMESH
         CALL REDGET(INDC,NITMA,FLOTT,TEXT13,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         IBASE(IMESH+I-1)=NITMA 
         IF(((IBASE(IMESH+I-1).LE.0).AND.(TEXT12.NE.'SPLITR')).OR.
     >       (IBASE(IMESH+I-1).EQ.0)) CALL XABORT
     >    (NAMSBR//': INVALID MESH-SPLITTING INDEX.')
   80    CONTINUE
         CALL LCMPUT(IPLIST,TEXT12,LMESH,1,IBASE(IMESH))
         CALL RLSARA(IBASE(IMESH))
      ELSE IF(TEXT12.EQ.'CELL') THEN
*        FORCE SUB GEOMETRIES AT SPECIFIC LOCATIONS.
         ISTATE(8)=1
         CALL SETARA(BASE,3*LREG,ICELL)
         CALL SETARA(IBASE,LREG,IIGEN)
         I=0
         IKG=0
  110    I=I+1
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.3) CALL XABORT(NAMSBR//': CHARACTER DATA EXPECTED.')
         IF((TEXT12(2:2).EQ.'-').OR.(TEXT12(2:2).EQ.'+').OR.
     1   (TEXT12.EQ.'HBC').OR.(TEXT12(1:4).EQ.'MESH').OR.
     2   (TEXT12(1:5).EQ.'SPLIT').OR.(TEXT12.EQ.'SIDE').OR.
     3   (TEXT12.EQ.'MERGE').OR.(TEXT12.EQ.'TURN').OR.(TEXT12.EQ.
     4   'CLUSTER').OR.(TEXT12(2:4).EQ.'PIN').OR.(TEXT12.EQ.'BIHET')
     5   .OR.(TEXT12.EQ.'POURCE').OR.(TEXT12.EQ.'PROCEL').OR.(TEXT12.EQ.
     6   ';').OR.(TEXT12.EQ.':::')) GO TO 120
         IF(I.GT.LREG) GO TO 500
         DO 115 J=1,I-1
         JKG=IBASE(IIGEN+J-1)
         WRITE(TEXT13(:4),'(A4)') BASE(ICELL+3*(JKG-1))
         WRITE(TEXT13(5:8),'(A4)') BASE(ICELL+3*(JKG-1)+1)
         WRITE(TEXT13(9:),'(A4)') BASE(ICELL+3*(JKG-1)+2)
         IF(TEXT12.EQ.TEXT13) THEN
            IBASE(IIGEN+I-1)=JKG
            GO TO 110
         ENDIF
  115    CONTINUE
         IKG=IKG+1
         IBASE(IIGEN+I-1)=IKG
         READ (TEXT12(:4),'(A4)') BASE(ICELL+3*(IKG-1))
         READ (TEXT12(5:8),'(A4)') BASE(ICELL+3*(IKG-1)+1)
         READ (TEXT12(9:),'(A4)') BASE(ICELL+3*(IKG-1)+2)
         GO TO 110
  120    LREG=I-1
         CALL LCMPUT(IPLIST,'CELL',3*IKG,3,BASE(ICELL))
         CALL LCMPUT(IPLIST,'GENERATING',LREG,1,IBASE(IIGEN))
         CALL RLSARA(IBASE(IIGEN))
         CALL RLSARA(BASE(ICELL))
         GO TO 35
      ELSE IF(TEXT12.EQ.'MERGE') THEN
*        INPUT CELL-MERGING INDCES.
         ISTATE(10)=1
         CALL SETARA(IBASE,LREG,IMERGE)
         I=0
  130    I=I+1
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.EQ.3) GO TO 140
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         IF(I.GT.LREG) GO TO 500
         IBASE(IMERGE+I-1)=NITMA
         GO TO 130
  140    LREG=I-1
         CALL LCMPUT(IPLIST,'MERGE',LREG,1,IBASE(IMERGE))
         CALL RLSARA(IBASE(IMERGE))
         GO TO 35
      ELSE IF(TEXT12.EQ.'TURN') THEN
*        INPUT ORIENTATION INFORMATION.
         CALL SETARA(IBASE,LREG,ITURN)
         I=0
  150    I=I+1
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.3) CALL XABORT(NAMSBR//': CHARACTER DATA EXPECTED.')
         DO 160 J=1,MAXTUR
         IF(TEXT12.EQ.CTUR(J)) THEN
            IF(I.GT.LREG) GO TO 500
            IBASE(ITURN+I-1)=J
            GO TO 150
         ELSE IF(TEXT12.EQ.'-'//CTUR(J)) THEN
            IF(I.GT.LREG) GO TO 500
            IBASE(ITURN+I-1)=MAXTUR+J
            GO TO 150
         ENDIF
  160    CONTINUE
         LREG=I-1
         CALL LCMPUT(IPLIST,'TURN',LREG,1,IBASE(ITURN))
         CALL RLSARA(IBASE(ITURN))
         GO TO 35
      ELSE IF(TEXT12.EQ.'CLUSTER') THEN
*        DEFINE CLUSTER SUB GEOMETRIES.
         IF(LR.EQ.0) GO TO 500
         CALL SETARA(BASE,3*MXCL,ICELL)
         I=0
  180    I=I+1
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.3) CALL XABORT(NAMSBR//': CHARACTER DATA EXPECTED.')
         IF((TEXT12(2:2).EQ.'-').OR.(TEXT12(2:2).EQ.'+').OR.
     1   (TEXT12.EQ.'HBC').OR.(TEXT12(1:4).EQ.'MESH').OR.(TEXT12(1:5)
     2   .EQ.'SPLIT').OR.(TEXT12.EQ.'SIDE').OR.(TEXT12.EQ.'MIX').OR.
     3   (TEXT12.EQ.'CELL').OR.(TEXT12.EQ.'MERGE').OR.(TEXT12.EQ.'TURN')
     4   .OR.(TEXT12(2:4).EQ.'PIN').OR.(TEXT12.EQ.'BIHET').OR.
     5   (TEXT12.EQ.'POURCE').OR.(TEXT12.EQ.'PROCEL').OR.(TEXT12.EQ.
     6   ';').OR.(TEXT12.EQ.':::')) GO TO 190
         IF(I.GT.MXCL) GO TO 500
         READ (TEXT12(:4),'(A4)') BASE(ICELL+3*(I-1))
         READ (TEXT12(5:8),'(A4)') BASE(ICELL+3*(I-1)+1)
         READ (TEXT12(9:),'(A4)') BASE(ICELL+3*(I-1)+2)
         GO TO 180
  190    CALL LCMPUT(IPLIST,'CLUSTER',3*(I-1),3,BASE(ICELL))
         ISTATE(13)=I-1
         CALL RLSARA(BASE(ICELL))
         GO TO 35
      ELSE IF(TEXT12.EQ.'NPIN') THEN
*        INPUT NUMBER OF PINS IN CLUSTER RING.
         IF((ISTATE(1).NE.3).AND.(ISTATE(1).NE.6)) GO TO 500
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         NPIN=NITMA
         CALL LCMPUT(IPLIST,'NPIN',1,1,NPIN)
      ELSE IF((TEXT12.EQ.'RPIN').OR.(TEXT12.EQ.'APIN')) THEN
*        INPUT RADIUS/ANGLE OF CLUSTER RING.
         IF((ISTATE(1).NE.3).AND.(ISTATE(1).NE.6)) GO TO 500
         CALL REDGET(INDC,NITMA,PIN,TEXT12,DBLINP)
         IF(INDC.NE.2) CALL XABORT(NAMSBR//': REAL DATA EXPECTED.')
         CALL LCMPUT(IPLIST,TEXT12,1,2,PIN)
      ELSE IF(TEXT12.EQ.'BIHET') THEN
*        DOUBLE HETEROGENEITY OPTION.
         ISTATE(12)=1
         IF(LEVEL.NE.1) CALL XABORT
     >    (NAMSBR//': BIHET DATA SHOULD BE WRITTEN ON FIRST '//
     >             'DIRECTORY LEVEL.')
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.3) CALL XABORT(NAMSBR//': CHARACTER DATA EXPECTED.')
         IF(TEXT12.EQ.'TUBE') THEN
            MICRO=3
         ELSE IF(TEXT12.EQ.'SPHE') THEN
            MICRO=4
         ELSE
            CALL XABORT(NAMSBR//': PROHIBITED TYPE OF MICRO GEOMETRY.')
         ENDIF
         CALL LCMPUT(IPLIST,'MICRO',1,1,MICRO)
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         NG=NITMA
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.') 
         NMILG=NITMA
*
         CALL SETARA(IBASE,NG,INS)
         NSMAX=0
         DO 200 I=1,NG
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         IBASE(INS+I-1)=NITMA
  200    NSMAX=MAX(NSMAX,IBASE(INS+I-1))
         CALL LCMPUT(IPLIST,'NS',NG,1,IBASE(INS))
*
         CALL SETARA(BASE,(NSMAX+1)*NG,IRS)
         DO 205 IOFJ=1,(NSMAX+1)*NG
  205    BASE(IRS+IOFJ-1)=0.0
         DO 210 I=1,NG
         DO 210 J=1,IBASE(INS+I-1)+1
         IOFJ=(I-1)*(NSMAX+1)+J
         CALL REDGET(INDC,NITMA,BASE(IRS+IOFJ-1),TEXT12,DBLINP)
         IF(INDC.NE.2) CALL XABORT(NAMSBR//': REAL DATA EXPECTED.')
  210    CONTINUE
         CALL LCMPUT(IPLIST,'RS',(NSMAX+1)*NG,2,BASE(IRS))
         CALL RLSARA(BASE(IRS))
*
         CALL SETARA(IBASE,NMILG,IMILIE)
         DO 220 I=1,NMILG
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         IBASE(IMILIE+I-1)=NITMA
  220    CONTINUE
         CALL LCMPUT(IPLIST,'MILIE',NMILG,1,IBASE(IMILIE))
         CALL RLSARA(IBASE(IMILIE))
*
         CALL SETARA(IBASE,NMILG,IMIXDL)
         DO 230 I=1,NMILG
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
         IF(INDC.NE.1) CALL XABORT(NAMSBR//': INTEGER DATA EXPECTED.')
         IBASE(IMIXDL+I-1)=NITMA
  230    CONTINUE
         CALL LCMPUT(IPLIST,'MIXDIL',NMILG,1,IBASE(IMIXDL))
         CALL RLSARA(IBASE(IMIXDL))
*
         CALL SETARA(IBASE,NSMAX*NG*NMILG,IMIXGR)
         DO 235 IOFK=1,NSMAX*NG*NMILG
  235    IBASE(IMIXGR+IOFK-1)=0
         CALL SETARA(BASE,NG*NMILG,IFRACT)
         DO 250 I=1,NMILG
         DO 240 J=1,NG
         IOFJ=(I-1)*NG+J
         CALL REDGET(INDC,NITMA,BASE(IFRACT+IOFJ-1),TEXT12,DBLINP)
         IF(INDC.NE.2) CALL XABORT(NAMSBR//': REAL DATA EXPECTED.')
  240    CONTINUE
         DO 250 J=1,NG
         IOFJ=(I-1)*NG+J
         IF(BASE(IFRACT+IOFJ-1).GT.0.0) THEN
            DO 245 K=1,IBASE(INS+J-1)
            IOFK=((I-1)*NG+(J-1))*NSMAX+K
            CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
            IF(INDC.NE.1) CALL XABORT
     >        (NAMSBR//': INTEGER DATA EXPECTED.')
            IBASE(IMIXGR+IOFK-1)=NITMA
  245       CONTINUE
         ENDIF
  250    CONTINUE
         CALL LCMPUT(IPLIST,'FRACT',NG*NMILG,2,BASE(IFRACT))
         CALL RLSARA(BASE(IFRACT))
         CALL LCMPUT(IPLIST,'MIXGR',NSMAX*NG*NMILG,1,IBASE(IMIXGR))
         CALL RLSARA(IBASE(IMIXGR))
*
         CALL RLSARA(IBASE(INS))
      ELSE IF(TEXT12.EQ.'POURCE') THEN
*        CELL PROPORTIONS FOR DO-IT-YOURSELF OPTION.
         IF(ISTATE(1).NE.30) GO TO 500
         CALL SETARA(BASE,LX,IPOURC)
         DO 260 I=1,LX
         CALL REDGET(INDC,NITMA,BASE(IPOURC+I-1),TEXT12,DBLINP)
         IF(INDC.NE.2) CALL XABORT(NAMSBR//': REAL DATA EXPECTED.')
  260    CONTINUE
         CALL LCMPUT(IPLIST,'POURCE',LX,2,BASE(IPOURC))
         CALL RLSARA(BASE(IPOURC))
      ELSE IF(TEXT12.EQ.'PROCEL') THEN
*        CELL PROBABILITIES FOR DO-IT-YOURSELF OPTION.
         IF(ISTATE(1).NE.30) GO TO 500
         CALL SETARA(BASE,LX*LX,IPROCE)
         DO 270 I=1,LX
         DO 270 J=1,LX
         IOFJ=(J-1)*LX+I
         CALL REDGET(INDC,NITMA,BASE(IPROCE+IOFJ-1),TEXT12,DBLINP)
         IF(INDC.NE.2) CALL XABORT(NAMSBR//': REAL DATA EXPECTED.')
  270    CONTINUE
         CALL LCMPUT(IPLIST,'PROCEL',LX*LX,2,BASE(IPROCE))
         CALL RLSARA(BASE(IPROCE))
      ELSE IF((TEXT12(2:2).EQ.'+').OR.(TEXT12(2:2).EQ.'-').OR.
     1   (TEXT12.EQ.'HBC')) THEN
*        INPUT BOUNDARY CONDITIONS.
         IF(TEXT12.EQ.'X-') THEN
            ISURF=1
            IF(LX.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'X+') THEN
            ISURF=2
            IF(LX.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'R+') THEN
            ISURF=2
            IF(LR.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'Y-') THEN
            ISURF=3
            IF(LY.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'Y+') THEN
            ISURF=4
            IF(LY.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'Z-') THEN
            ISURF=5
            IF(LZ.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'Z+') THEN
            ISURF=6
            IF(LZ.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'HBC') THEN
            ISURF=1
            IF(.NOT.LHEX) CALL XABORT(NAMSBR//': HBC PROHIBITED.')
            CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DBLINP)
            IF(INDC.NE.3) CALL XABORT
     >        (NAMSBR//': CHARACTER DATA EXPECTED.')
            DO 280 I=1,MAXHEX
            IF(TEXT12.EQ.CHEX(I)) THEN
               IHEX=I
               GO TO 285
            ENDIF
  280       CONTINUE
            CALL XABORT(NAMSBR//': INVALID TYPE OF HEXAGONAL SYMMETRY.')
  285       CALL LCMPUT(IPLIST,'IHEX',1,1,IHEX)
         ELSE
            GO TO 500
         ENDIF
         CALL REDGET(INDC,NITMA,FLOTT,TEXT4,DBLINP)
         IF(INDC.NE.3) CALL XABORT(NAMSBR//': CHARACTER DATA EXPECTED.')
         DO 290 I=1,MAXCOD
         IF(TEXT4.EQ.COND(I)) THEN
            NCODE(ISURF)=I
            GO TO 295
         ENDIF
  290    CONTINUE
         CALL XABORT(NAMSBR//': INVALID TYPE OF BOUNDARY CONDITION.')
  295    IF(TEXT4.EQ.'ALBE') THEN
            CALL REDGET(INDC,NITMA,FLOTT,TEXT4,DBLINP)
            IF(INDC.EQ.1) THEN
               ICODE(ISURF)=NITMA
               MINICO=MIN(MINICO,NITMA)
            ELSE IF(INDC.EQ.2) THEN
               ZCODE(ISURF)=FLOTT
            ELSE
               CALL XABORT(NAMSBR//': INTEGER OR REAL DATA EXPECTED.')
            ENDIF
         ELSE IF(TEXT4.EQ.'REFL') THEN
            ZCODE(ISURF)=1.0
         ELSE IF(TEXT4.EQ.'VOID') THEN
            ZCODE(ISURF)=0.0
         ENDIF
      ELSE IF(TEXT12.EQ.';') THEN
*        END-OF-GEOMETRY.
         GO TO 320
      ELSE
         CALL XABORT(NAMSBR//': '//TEXT12//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 30
*
  320 TEXT12='L_GEOM'
      READ(TEXT12,'(3A4)') (KCHAR(I1),I1=1,3)
      CALL LCMPUT(IPLIST,'SIGNATURE',3,3,KCHAR)
      CALL LCMPUT(IPLIST,'STATE-VECTOR',NSTATE,1,ISTATE)
      CALL LCMPUT(IPLIST,'NCODE',6,1,NCODE)
      CALL LCMPUT(IPLIST,'ZCODE',6,2,ZCODE)
      CALL LCMPUT(IPLIST,'ICODE',6,1,ICODE)
      IF(MINMIX.LT.0)
     >  CALL XABORT(NAMSBR//': NEGATIVE MIXTURE NUMBERS INVALID')
      IF(MINICO.LT.1)
     >  CALL XABORT(NAMSBR//': ALBEDO NUMBER MUST BE GREATER THAN 0')
      MAXMIX=ISTATE(7)
      IF(IMPX.GT.0) THEN
        NAMT=' '
        CALL LCMNXT(IPLIST,NAMT,TEXT12,TEXT13,LCM)
        WRITE(IOUT,6000) LEVEL,GEONAM,TEXT12,TYPE(ISTATE(1))
      ENDIF
      IF(IMPX.GT.1) THEN
        WRITE(IOUT,6010) ISTATE(1),TYPE(ISTATE(1)),(ISTATE(I),I=2,13)
      ENDIF
      IF((ISTATE(8).EQ.1).AND.(ISTATE(9).EQ.0)) GO TO 500
      RETURN
  500 CALL XABORT(NAMSBR//': INVALID DATA.')
*
 6000 FORMAT(/' CREATION OF A LEVEL ',I3,' GEOMETRY'/
     >        ' GEOMETRY NAME    = ',4X,A12/
     >        ' LINKED LIST NAME = ',4X,A12/
     >        ' GEOMETRY TYPE    = ',4X,A16)
 6010 FORMAT(/' GEOMETRY PARAMETER VECTOR:'/
     > ' ITYPE = ',I6,' (',A16,')'/
     > ' LR    = ',I6,' (NUMBER OF TUBES)'/
     > ' LX    = ',I6,' (X-DIMENSION INDEX)'/
     > ' LY    = ',I6,' (Y-DIMENSION INDEX)'/
     > ' LZ    = ',I6,' (Z-DIMENSION INDEX)'/
     > ' LREG  = ',I6,' (NUMBER OF REGIONS)'/
     > ' MAXMIX= ',I6,' (MAX. NB. OF MIXTURES/0=TRANSPARENT GEOMETRY)'/
     > ' ISUB1 = ',I6,' (1=COMMAND CELL IS USED/0=ELSE)'/
     > ' ISUB2 = ',I6,' (NUMBER OF SUB GEOMETRIES)'/
     > ' IMERGE= ',I6,' (1=CELL-MERGING/0=ELSE)'/
     > ' ISPLIT= ',I6,' (1=MESH-SPLITTING/0=ELSE)'/
     > ' IBIHET= ',I6,' (1=DOUBLE HETEROGENEITY/0=ELSE)'/
     > ' ICLUST= ',I6,' (NUMBER OF CLUSTER RINGS)'/)
      END
