*DECK MACPRM
      SUBROUTINE MACPRM(IPMACR,IPRINT,NGROUP,NANISO,NBMIXF,NIFISF,
     >                  NEDF  ,NREACD,NTREA ,IGR   ,NAMREA,
     >                  NAMEDN,IXSPRO,XSGEN ,XSSCAT,SCTMP ,ISCAT)
C
C---------------------------  MACPRM  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : MACPRM
C       USE      : SAVE A NEW MACROLIB CREATED FROM OLD MACROLIBS
C       MODIFIED : 98-06-04
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C       IPMACR   : POINTER TO STRUCTURES               I
C       IPRINT   : PRINT LEVEL                         I
C       NGROUP   : NUMBER OF GROUPS                    I
C       NANISO   : MAXIMUN SCATTERING ANISOTROPY       I
C       NBMIXF   : FINAL NUMBER OF MIXTURES            I
C       NIFISF   : FINAL NUMBER FISSILE ISOTOPES       I
C       NEDF     : FINAL NUMBER OF ADITIONAL X-S       I
C       NREACD   : NUMBER OF DEFAULT XS                I
C       NTREA    : TOTAL NUMBER OF XS                  I
C       IGR      : CURRENT GROUP BEING PROCESSED       I
C       NAMREA   : NAME OF DEFAULT XS                  C(NREACD)*12
C       NAMEDN   : NAME OF EDIT XS                     I(2,NEDF)
C       IXSPRO   : FLAG FOR CROSS SECTION PROCESSING   I(NTREA
C                                                      +NANISO)
C       XSGEN    : GENERAL XS VECTOR                   R(NBMIXF,
C                                                        NTREA)
C       XSSCAT   : GENERAL SCATTERING MATRIX           R(NGROUP,
C                                                  NBMIXF,NANISO,2)
C       SCTMP    : TEMPORARY SCATTERING MATRIX         R(NGROUP*
C                                                        NBMIXF)
C       ISCAT    : SCATTERING POINTER                  I(NBMIXF,3)
C   3- INTERNAL PARAMETERS:
C
C---------------------------   MACPRM  --------------------------------
C
      IMPLICIT     NONE
      INTEGER      IOUT,ILCMUP,ILCMDN
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='MACPRM')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER      IPMACR,IPRINT,NGROUP,NANISO,NBMIXF,NIFISF,
     >             NEDF,NREACD,NTREA,IGR
      CHARACTER    NAMREA(NREACD)*12
      INTEGER      NAMEDN(2,NEDF),IXSPRO(NTREA+NANISO),ISCAT(NBMIXF,3)
      REAL         XSGEN(NBMIXF,NTREA),XSSCAT(NGROUP,NBMIXF,NANISO,2),
     >             SCTMP(NGROUP*NBMIXF)
C----
C  LOCAL PARAMETERS
C----
      INTEGER      IMIX,IREA,IREAF,IREAP,IREAT,IREAA,
     >             IED,IANIS,IGD,IGF,JGR,ITC,NELEM
      CHARACTER    NAMADD*12,CANISO*2
C----
C  PRINT HEADER
C----
      IF(IPRINT .GE. 10) THEN
        WRITE(IOUT,6000) NAMSBR
      ENDIF
C----
C  1) DEFAULT XS
C----
      DO 100 IREA=1,NREACD
        IF(IXSPRO(IREA) .EQ. 1) THEN
          IF(IPRINT .GE. 10) THEN
            WRITE(IOUT,6010) NAMREA(IREA)
          ENDIF
          CALL LCMPUT(IPMACR,NAMREA(IREA),NBMIXF,
     >                2,XSGEN(1,IREA))
        ENDIF
 100  CONTINUE
C----
C  2) CHI AND NUSIGF
C----
      IF(NIFISF .GT. 0) THEN
        IREAF=NREACD+1
        IREAT=NREACD+NIFISF+1
        IREAP=NREACD+2*NIFISF+1
        IF(IXSPRO(IREAF) .EQ. 1) THEN
          IF(IPRINT .GE. 10) THEN
            WRITE(IOUT,6010) 'NUSIGF      '
          ENDIF
          CALL LCMPUT(IPMACR,'NUSIGF      ',NBMIXF*NIFISF,
     >                2,XSGEN(1,IREAF))
        ENDIF
        IF(IXSPRO(IREAT) .EQ. 1) THEN
          IF(IPRINT .GE. 10) THEN
            WRITE(IOUT,6010) 'NFTOT       '
          ENDIF
          CALL LCMPUT(IPMACR,'NFTOT       ',NBMIXF*NIFISF,
     >                2,XSGEN(1,IREAT))
        ENDIF
        IF(IXSPRO(IREAP) .EQ. 1) THEN
          IF(IPRINT .GE. 10) THEN
            WRITE(IOUT,6010) 'CHI         '
          ENDIF
          CALL LCMPUT(IPMACR,'CHI         ',NBMIXF*NIFISF,
     >                2,XSGEN(1,IREAP))
        ENDIF
      ENDIF
C----
C  3) ADDITIONAL EDIT XS
C----
      IF(NEDF .GT. 0) THEN
        IREAA=NREACD+3*NIFISF
        DO 120 IED=1,NEDF
          IF(IXSPRO(IREAA+IED) .EQ. 1) THEN
            WRITE(NAMADD,'(A4,A2)') (NAMEDN(ITC,IED),ITC=1,2)
            IF(IPRINT .GE. 10) THEN
              WRITE(IOUT,6010) NAMADD
            ENDIF
            CALL LCMPUT(IPMACR,NAMADD,NBMIXF,
     >                  2,XSGEN(1,IREAA+IED))
          ENDIF
 120    CONTINUE
      ENDIF
C----
C  4) SCATTERING XS
C----
      DO 130 IANIS=1,NANISO
        IF(IXSPRO(NTREA+IANIS) .EQ. 1) THEN
          WRITE(CANISO,'(I2)') IANIS-1
          IF(IPRINT .GE. 10) THEN
            WRITE(IOUT,6010) 'SCATTERING'//CANISO
          ENDIF
          CALL XDRSET(XSGEN,NBMIXF,0.0)
C----
C  4.3) TREAT SCAT
C----
          NELEM=0
          DO 140 IMIX=1,NBMIXF
            IGD=IGR
            IGF=IGR
            XSGEN(IMIX,1)=XSSCAT(IGR,IMIX,IANIS,1)
            DO 141 JGR=1,NGROUP
              IF(XSSCAT(JGR,IMIX,IANIS,1) .NE. 0) THEN
                IGD=MAX(IGD,JGR)
                IGF=MIN(IGF,JGR)
              ENDIF
 141        CONTINUE
            ISCAT(IMIX,1)=IGD
            ISCAT(IMIX,2)=IGD-IGF+1
            ISCAT(IMIX,3)=NELEM+1
            DO 142 JGR=IGD,IGF,-1
              NELEM=NELEM+1
              SCTMP(NELEM)=XSSCAT(JGR,IMIX,IANIS,1)
 142        CONTINUE
 140      CONTINUE
          CALL LCMPUT(IPMACR,'SIGW'//CANISO,NBMIXF,
     >                2,XSGEN(1,1))
          CALL LCMPUT(IPMACR,'IJJD'//CANISO,NBMIXF,
     >                1,ISCAT(1,1))
          CALL LCMPUT(IPMACR,'NJJD'//CANISO,NBMIXF,
     >                1,ISCAT(1,2))
          CALL LCMPUT(IPMACR,'IPOD'//CANISO,NBMIXF,
     >                1,ISCAT(1,3))
          CALL LCMPUT(IPMACR,'SCAD'//CANISO,NELEM,
     >                2,SCTMP)
          NELEM=0
          DO 150 IMIX=1,NBMIXF
            IGD=IGR
            IGF=IGR
            DO 151 JGR=1,NGROUP
              IF(XSSCAT(JGR,IMIX,IANIS,2) .NE. 0) THEN
                IGD=MAX(IGD,JGR)
                IGF=MIN(IGF,JGR)
              ENDIF
 151        CONTINUE
            ISCAT(IMIX,1)=IGD
            ISCAT(IMIX,2)=IGD-IGF+1
            ISCAT(IMIX,3)=NELEM+1
            DO 152 JGR=IGD,IGF,-1
              NELEM=NELEM+1
              SCTMP(NELEM)=XSSCAT(JGR,IMIX,IANIS,2)
 152        CONTINUE
 150      CONTINUE
          CALL LCMPUT(IPMACR,'IJJA'//CANISO,NBMIXF,
     >                1,ISCAT(1,1))
          CALL LCMPUT(IPMACR,'NJJA'//CANISO,NBMIXF,
     >                1,ISCAT(1,2))
          CALL LCMPUT(IPMACR,'IPOA'//CANISO,NBMIXF,
     >                1,ISCAT(1,3))
          CALL LCMPUT(IPMACR,'SCAA'//CANISO,NELEM,
     >                2,SCTMP)
        ENDIF
 130  CONTINUE
      RETURN
C----
C  EDIT FORMATS
C----
 6000 FORMAT(1X,A6,' - SAVING CROSS SECTIONS '/)
 6010 FORMAT(7X,   '   SAVING RECORD         : ',A12)
      END
