*DECK MACWXS
      SUBROUTINE MACWXS(IPMACR,IPRINT,NBMIX ,NGROUP,NANISO,NIFISS,
     >                  ITRANC,NEDMAC,NBWRK ,
     >                  INGSCT,IFGSCT,IPOSCT,XSWORK,CADNAM)
C
C---------------------------  MACWXS  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : MACWXS
C       USE      : PRINT/CHECK X-S INFORMATION IF REQUIRED
C       MODIFIED : 08-02-1988
C       AUTHOR   : G.MARLEAU AND A.HEBERT
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       IPMACR   : POINTER TO THE MACROLIB            I
C       IPRINT   : PRINT LEVEL                        I
C       NBMIX    : NUMBER OF MIXTURES                 I
C       NGROUP   : NUMBER OF ENERGY GROUPS            I
C       NANISO   : MAXIMUM LEGENDRE ORDER             I
C                  = 1 ISOTROPIC COLLISION
C                  = 2 LINEARLY ANISOTROPIC COLLISION
C       NIFISS   : NUMBER OF FISSILE ISOTOPES         I
C       ITRANC   : TYPE OF TRANSPORT CORRECTION       I
C       NEDMAC   : NUMBER OF MACRO EDIT X-SEXTIONS    I
C       NBWRK    : DIEMNSION WORK VECTOR              I
C       INGSCT   : NB OF SCATTERING GROUP FOR  XS     I(NBMIX)
C       IFGSCT   : FIRST SCATTERING GROUP FOR  XS     I(NBMIX)
C       IPOSCT   : MIXTURE LOCATION IN XS MATRIX      I(NBMIX)
C    WORK VECTORS
C       XSWORK   : WORK CROSS-SECTION VECTOR          R(NBWRK)
C       CADNAM   : ADD XS NAME                        I(2,NEDMAC+1)
C
C   3- INTERNAL PARAMETERS:
C
C         ILCMUP  : UP SWICH FOR LCM                   I
C         ILCMDN  : DOWN SWICH FOR LCM                 I
C         CGRPNM  : NAME OF LCM GROUP RECORDS          C*12
C         CANISO  : ANISOTROPY ORDER NUMBER            C*2
C
C---------------------------   MACWXS  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      REAL        EPS
      PARAMETER  (IOUT=6,ILCMUP=1,ILCMDN=2,EPS=1.0E-5,
     >            NAMSBR='MACWXS')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPMACR,IPRINT,NBMIX,NGROUP,NANISO,NIFISS,ITRANC,
     >            NEDMAC,NBWRK
      INTEGER     INGSCT(NBMIX),IFGSCT(NBMIX),IPOSCT(NBMIX),
     >            CADNAM(2,NEDMAC+1)
      REAL        XSWORK(NBWRK)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CGRPNM*12,CANISO*2,NAMREC*12,CEDNAM*12
      INTEGER     ILCMLN,ILCMTY,IANIS,IFIS,IGR,IMIX,ITC,IED,ILCFT,
     >            ILCXS,ILCCH,MAXMXR,IDEB,IFIN,IGD,IGF,IDIAG,IPO,ILFTO
      REAL        XSREF,XSERR
C----
C  START PRINTING
C----
      IF(IPRINT .GE. 2) THEN
        WRITE(IOUT,6000) NAMSBR
      ENDIF
      IF(NEDMAC .GT.  0 ) THEN
        CALL LCMGET(IPMACR,'ADDXSNAME',CADNAM)
      ENDIF  
      DO 100 IGR=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
        CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
C----
C  PRINT TOTAL X-S AND FIXE SOURCES INFORMATION.
C----
        IF(IPRINT .GE. 2) THEN
          IF(NBMIX .LE. 7) THEN
            WRITE(IOUT,6001) IGR,(ITC,ITC=1,NBMIX)
          ELSE
            WRITE(IOUT,6001) IGR,(ITC,ITC=1,7)
            WRITE(IOUT,6011) (ITC,ITC=8,NBMIX)
          ENDIF
          CALL LCMGET(IPMACR,'TOTAL',XSWORK)
          IF(NBMIX .LE. 7) THEN
            WRITE(IOUT,6002) 'TOTAL       ',
     >                       (XSWORK(ITC),ITC=1,NBMIX)
          ELSE
            WRITE(IOUT,6002) 'TOTAL       ',
     >                       (XSWORK(ITC),ITC=1,7)
            WRITE(IOUT,6010) (XSWORK(ITC),ITC=8,NBMIX)
          ENDIF
          IF(ITRANC .NE. 0) THEN
            CALL LCMGET(IPMACR,'TRANC',XSWORK)
            IF(NBMIX .LE. 7) THEN
              WRITE(IOUT,6002) 'TRANC       ',
     >                         (XSWORK(ITC),ITC=1,NBMIX)
            ELSE
              WRITE(IOUT,6002) 'TRANC       ',
     >                         (XSWORK(ITC),ITC=1,7)
              WRITE(IOUT,6010) (XSWORK(ITC),ITC=8,NBMIX)
            ENDIF
          ENDIF
          CALL LCMLEN(IPMACR,'FIXE',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'FIXE',XSWORK)
            IF(NBMIX .LE. 7) THEN
              WRITE(IOUT,6002) 'FIXE        ',
     >                         (XSWORK(ITC),ITC=1,NBMIX)
            ELSE
              WRITE(IOUT,6002) 'FIXE        ',(XSWORK(ITC),ITC=1,7)
              WRITE(IOUT,6010) (XSWORK(ITC),ITC=8,NBMIX)
            ENDIF
          ENDIF
          CALL LCMLEN(IPMACR,'FIXA',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'FIXA',XSWORK)
            IF(NBMIX .LE. 7) THEN
              WRITE(IOUT,6002) 'FIXA        ',
     >                         (XSWORK(ITC),ITC=1,NBMIX)
            ELSE
              WRITE(IOUT,6002) 'FIXA        ',
     >                         (XSWORK(ITC),ITC=1,7)
              WRITE(IOUT,6010) (XSWORK(ITC),ITC=8,NBMIX)
            ENDIF
          ENDIF
          CALL LCMLEN(IPMACR,'FIXG',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'FIXG',XSWORK)
            IF(NBMIX .LE. 7) THEN
              WRITE(IOUT,6002) 'FIXG        ',
     >                         (XSWORK(ITC),ITC=1,NBMIX)
            ELSE
              WRITE(IOUT,6002) 'FIXG        ',
     >                         (XSWORK(ITC),ITC=1,7)
              WRITE(IOUT,6010) (XSWORK(ITC),ITC=8,NBMIX)
            ENDIF
          ENDIF
C----
C  PRINT FISSION INFORMATION.
C----
          ILFTO=0
          CALL LCMLEN(IPMACR,'NFTOT ',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) ILFTO=1
          CALL LCMLEN(IPMACR,'NUSIGF',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'NUSIGF',XSWORK)
            IF(ILFTO .EQ. 1)
     >      CALL LCMGET(IPMACR,'NFTOT ',XSWORK(NBMIX*NIFISS+1))
            CALL LCMGET(IPMACR,'CHI   ',XSWORK(2*NBMIX*NIFISS+1))
            ILCXS=0
            ILCFT=NBMIX*NIFISS
            ILCCH=2*NBMIX*NIFISS
            DO 110 IFIS=1,NIFISS
              IF(NBMIX .LE. 7) THEN
                WRITE(IOUT,6012) 'NUSIGF',IFIS,
     >            (XSWORK(ITC),ITC=ILCXS+1,ILCXS+NBMIX)
                IF(ILFTO .EQ. 1) THEN
                  WRITE(IOUT,6012) 'NFTOT ',IFIS,
     >              (XSWORK(ITC),ITC=ILCFT+1,ILCFT+NBMIX)
                ENDIF
                WRITE(IOUT,6012) 'CHI   ',IFIS,
     >            (XSWORK(ITC),ITC=ILCCH+1,ILCCH+NBMIX)
              ELSE
                WRITE(IOUT,6012) 'NUSIGF',IFIS,
     >            (XSWORK(ITC),ITC=ILCXS+1,ILCXS+7)
                WRITE(IOUT,6010)
     >            (XSWORK(ITC),ITC=ILCXS+8,ILCXS+NBMIX)
                IF(ILFTO .EQ. 1) THEN
                  WRITE(IOUT,6012) 'NFTOT ',IFIS,
     >              (XSWORK(ITC),ITC=ILCFT+1,ILCFT+7)
                  WRITE(IOUT,6010)
     >              (XSWORK(ITC),ITC=ILCFT+8,ILCFT+NBMIX)
                  ENDIF
                WRITE(IOUT,6012) 'CHI   ',IFIS,
     >            (XSWORK(ITC),ITC=ILCCH+1,ILCCH+7)
                WRITE(IOUT,6010)
     >            (XSWORK(ITC),ITC=ILCCH+8,ILCCH+NBMIX)
              ENDIF
              ILCXS=ILCXS+NBMIX
              ILCFT=ILCFT+NBMIX
              ILCCH=ILCCH+NBMIX
 110        CONTINUE
          ENDIF
        ENDIF
C----
C  PRINT SCATTERING MATRICES INFORMATION.
C----
        DO 120 IANIS=1,NANISO
          WRITE(CANISO,'(I2)') IANIS-1
          NAMREC='SIGW'//CANISO
          CALL LCMLEN(IPMACR,NAMREC,ILCMLN,ILCMTY)
          IF(ILCMLN .GT. NBMIX) THEN
            CALL XABORT(NAMSBR//
     >      ': NUMBER OF MIXTURES ON MACROLIB IS INCOHERENT')
          ELSE IF(ILCMLN .GT. 0) THEN
            MAXMXR=ILCMLN
            IF(IPRINT .GE. 2) THEN
              CALL LCMGET(IPMACR,NAMREC,XSWORK)
              IF(NBMIX .LE. 7) THEN
                WRITE(IOUT,6002) NAMREC,
     >                          (XSWORK(ITC),ITC=1,MAXMXR)
              ELSE
                WRITE(IOUT,6002) NAMREC,
     >                          (XSWORK(ITC),ITC=1,7)
                WRITE(IOUT,6010) (XSWORK(ITC),ITC=8,MAXMXR)
              ENDIF
            ENDIF
            IF(IPRINT .GT. 5) THEN
              NAMREC='SCAD'//CANISO
              CALL LCMGET(IPMACR,'NJJD'//CANISO,INGSCT)
              CALL LCMGET(IPMACR,'IJJD'//CANISO,IFGSCT)
              CALL LCMGET(IPMACR,NAMREC,XSWORK(NBMIX+1))
              IFIN=NBMIX+1
              IDEB=NBMIX+INGSCT(1)
              IGD=IFGSCT(1)
              IGF=IGD-INGSCT(1)+1
              IDIAG=IDEB+IGF-IGR
              IF(INGSCT(1) .GT. 0) THEN
                IF(IDEB-IFIN+1 .LE. 4) THEN
                  WRITE(IOUT,6004) NAMREC,1,IGF,IGD,
     >                             (XSWORK(ITC),ITC=IDEB,IFIN,-1)
                ELSE
                  WRITE(IOUT,6004) NAMREC,1,IGF,IGF,
     >                             (XSWORK(ITC),ITC=IDEB,IDEB-3,-1)
                  WRITE(IOUT,6010) (XSWORK(ITC),ITC=IDEB-4,IFIN,-1)
                ENDIF
              ENDIF
              DO 130 IMIX=2,MAXMXR
                IFIN=IDEB+1
                IDEB=IDEB+INGSCT(IMIX)
                IGD=IFGSCT(IMIX)
                IGF=IGD-INGSCT(IMIX)+1
                IDIAG=IDEB+IGF-IGR
                IF(INGSCT(IMIX) .GT. 0) THEN
                  IF(IDEB-IFIN+1 .LE. 4) THEN
                    WRITE(IOUT,6005) IMIX,IGF,IGD,
     >                               (XSWORK(ITC),ITC=IDEB,IFIN,-1)
                  ELSE
                    WRITE(IOUT,6005) IMIX,IGF,IGD,
     >                               (XSWORK(ITC),ITC=IDEB,IDEB-3,-1)
                    WRITE(IOUT,6010) (XSWORK(ITC),ITC=IDEB-4,IFIN,-1)
                  ENDIF
                ENDIF
 130          CONTINUE
            ENDIF
            IF(IPRINT .GE. 10) THEN
              NAMREC='IPOD'//CANISO
              CALL LCMGET(IPMACR,NAMREC,IPOSCT)
C----
C  VALIDATION OF SCATTERING INFORMATION.
C----
              IPO=0
              DO 90 IMIX=1,NBMIX
                IGD=IFGSCT(IMIX)
                IGF=IGD-INGSCT(IMIX)+1
                IF(IPOSCT(IMIX) .NE. IPO+1) THEN
                  WRITE(IOUT,6006) NAMREC,IGR,IMIX
                ENDIF
                XSREF=XSWORK(IMIX)
                IF(XSREF .GT. 0.0) THEN
                  XSERR=ABS((XSREF-XSWORK(NBMIX+IPO+1+IGD-IGR))/XSREF)
                  IF(XSERR .GT. EPS) THEN
                    NAMREC='SIGW'//CANISO
                    WRITE(IOUT,6006) NAMREC,IGR,IMIX
                    WRITE(IOUT,'(7H ERROR=,1P,E15.5)') XSERR
                  ENDIF
                ENDIF
                IPO=IPO+INGSCT(IMIX)
  90          CONTINUE
            ENDIF
          ENDIF
 120    CONTINUE
        IF(IPRINT .GE. 5) THEN
C----
C  PRINT ADDITIONAL XS INFORMATION IF REQUIRED
C----
          IF(NEDMAC .GT. 0) THEN
            DO 200 IED=1,NEDMAC
              WRITE(CEDNAM,'(3A4)')
     >          CADNAM(1,IED),CADNAM(2,IED),'    '
              CALL LCMGET(IPMACR,CEDNAM,XSWORK)
              IF(NBMIX .LE. 6) THEN
                WRITE(IOUT,6007) CEDNAM,(XSWORK(ITC),ITC=1,NBMIX)
              ELSE
                WRITE(IOUT,6007) CEDNAM,(XSWORK(ITC),ITC=1,6)
                WRITE(IOUT,6010) (XSWORK(ITC),ITC=7,NBMIX)
              ENDIF
 200        CONTINUE
          ENDIF
        ENDIF
        CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 100  CONTINUE
      RETURN
C----
C  FORMAT
C----
 6000 FORMAT(//1X,A6,' PRINTING X-S STORED ON MACROLIB'/
     >          1X,38('-'))
 6001 FORMAT(/' G R O U P : ',I5/' MIXTURE',I8,6I16)
 6002 FORMAT(1X,A12,1P,7E16.8)
 6004 FORMAT(1X,A12,1X,'MIXTURE:',I5,3X,'FROM GROUPS:',I5,' TO ',I5,5X,
     >1P,4E16.8)
 6005 FORMAT(14X,'MIXTURE:',I5,3X,'FROM GROUPS:',I5,' TO ',I5,5X,
     >1P,4E16.8)
 6006 FORMAT(/39H MACWXS: INCONSISTENT VALUE OF RECORD ',A12,7H' IN GR,
     >3HOUP,I4,12H AND MIXTURE,I6,1H.)
 6007 FORMAT(1X,'ADDITIONAL XS : ',A12,1P,6E16.8)
 6010 FORMAT(1P,(13X,7E16.8))
 6011 FORMAT(7I16)
 6012 FORMAT(1X,A6,3X,I3,1P,7E16.8)
      END
